SystemOrganization addCategory: #'RPSS-View'!
SystemOrganization addCategory: #'RPSS-Model'!
SystemOrganization addCategory: #'RPSS-Test'!

WAComponent subclass: #RPSS_Main
	instanceVariableNames: 'system administrator page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_Main class methodsFor: 'testing' stamp: 'BogatchevOleg 10/16/2011 13:21'!
canBeRoot
	^true.! !

!RPSS_Main methodsFor: 'helpers' stamp: 'TimLenertz 10/25/2011 12:56'!
currentUser
	^ RPSS_System uniqueInstance getUserWithEmail: self session visitor email! !

!RPSS_Main methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 12:56'!
initialize 
	super initialize.
	system := RPSS_System uniqueInstance.
	system isInitialized 
	ifFalse: 
	[
		administrator := RPSS_Administrator new.
	].
	page := nil.
	! !

!RPSS_Main methodsFor: 'helpers' stamp: 'RobinDevooght 11/5/2011 11:57'!
linkTo: className

self session visitor setModule: className new
! !

!RPSS_Main methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 14:02'!
renderAdminMenuOn: html

html paragraph: 
[
	html anchor callback: [self linkTo: RPSS_AdminPanel];
		with: 'Administration tools'
].

! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 11/8/2011 16:46'!
renderConnectedMenuOn: html

self session visitor isAdministrator ifTrue: [self renderAdminMenuOn: html].


html unorderedList:   
[
	html listItem: 
	[
		html anchor callback: [self linkTo: RPSS_CharClassList]; 
			with: 'Character Classes'
	].
	html listItem:
	[
		html anchor callback: [self linkTo: RPSS_CharList];
			with: 'Characters'
	].
	html listItem: 
	[
		html anchor callback: [self linkTo: RPSS_UserPage. self session visitor module setPage: 'personal']; 
			with: 'Personal data'
	].
	html listItem: 
	[
		html anchor callback: [self linkTo: RPSS_UserFiles]; 
			with: 'Files'
	].
	html listItem: 
	[
		html anchor callback: [self linkTo: RPSS_UserGames]; 
			with: 'Games'
	].
].

html paragraph: [html anchor callback: [self session visitor logout]; with: 'Logout'].
! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 10:30'!
renderContentOn: html
		html div class: #header; with: [self renderHeader: html].
		html div class: #menu; with: [self renderMenu: html].
		html div class: #main; with: [self renderMain: html].
		html div class: #footer; with: [self renderFooter:html].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/18/2011 20:50'!
renderFirstAdministrator: html
	html form: 
	[
		html paragraph: 'Your e-mail adress:'.
		html textInput callback: [ :value | administrator email: value ].
		html paragraph: 'Your password:'.
		html textInput
			type: 'password';
			callback: [ :value | administrator password: value ].
		html break.
		html paragraph: 'Email confirmation'.
		html checkbox
			value: true;
			callback: [ :value | administrator confirmEmail: value ].
		html break.
		html paragraph: 'Email confirmation of every new user'.
		html checkbox
			value: true;
			callback: [ :value | system userApprovedByAdmin: value ].
		html break.
		html submitButton
			callback: [ administrator create: html];
			value: 'Initialize!!'
	]! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 10:54'!
renderFooter: html
	html text: ''.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'RobinDevooght 11/6/2011 17:44'!
renderHeader: html
	html heading: 'RolePlay Support System'.
	self session visitor isLogedIn ifTrue: 
	[
		html text: 'Logged in as ', self session visitor email.
	].
	self renderMessage: html.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 14:55'!
renderMain: html
	system isInitialized 
	ifTrue: 
	[
		
		self session visitor isLogedIn not & self session visitor module = nil ifTrue: 
		[
			html paragraph: 'Welcome to RPSS by group 9, system is ready'.
			html paragraph: 'Please login or create a new user'.
		]
		ifFalse: 
		[	
			html render: self session visitor module.
		].

	]
	ifFalse: 
	[
		html paragraph: 'System is not yet initialized, please input the administrator data'.
		self renderFirstAdministrator: html.
	].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 12:01'!
renderMenu: html
	self session visitor isLogedIn 
	ifTrue: 
	[
			self renderConnectedMenuOn: html.
	]
	ifFalse: 
	[
		html paragraph: [html anchor callback: [self session visitor setModule: self session visitor.]; with: 'Login'].
		html paragraph: [html anchor callback: [self linkTo: RPSS_UserCreation]; with: 'Register'].
	].
! !

!RPSS_Main methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 14:34'!
renderMessage:html
	self session message ifNotEmpty: [
		html unorderedList: [
			self session message do: [ 
				:message | html listItem: message 
			]
		]
	].
	self session visitor clearMessage.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 11/6/2011 01:41'!
style 
	^ '
.header {
	height: 100px;
	width: 100%;
	position: relative;
	vertical-align: top;
}
.menu {
	width: 200px;
	position: relative;
	float: left;
	left: 0px;
	top: 0px;
}
.footer{
	width: 100%;
	position: static;
	vertical-align: bottom;
	clear: both;
	float: none;
	height: 100px;
}
.main {
	position: relative;
	float: left;
	left: 0px;
	top: 0px;
}'! !

WAComponent subclass: #RPSS_SiteModule
	instanceVariableNames: 'visitor page system user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

RPSS_SiteModule subclass: #RPSS_AdminPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 16:41'!
editSettingsOf: aUser
	self session visitor setModule: ((RPSS_EditUserSettings user: user) editedUser: aUser; yourself)! !

!RPSS_AdminPanel methodsFor: 'initialization' stamp: 'RobinDevooght 11/5/2011 12:48'!
initialize 
	super initialize.
	! !

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 15:35'!
renderContentOn: html

page = #default ifTrue: [self renderDefaultOn: html].
page = #approval ifTrue: [self renderUserApprovalOn: html].
page = #storageSettings ifTrue: [self renderStorageSpaceSettingsOn: html].
page = #registeredUsers ifTrue: [self renderRegisteredUsersOn: html].! !

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 15:35'!
renderDefaultOn: html

html unorderedList: 
[
	html listItem: 
	[
		html anchor callback: [page := #approval]; 
			with: 'Manage pending approvals'
	].
	html listItem: 
	[
		html anchor callback: [page := #storageSettings]; 
			with: 'Manage storage space settings'
	].
	html listItem: 
	[
		html anchor callback: [page := #registeredUsers]; 
			with: 'Manage registered users'
	].
]! !

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 14:14'!
renderRegisteredUsersOn: html
	"Affiche la liste des utilisateurs dont l'inscription est complete"
	
	
	html orderedList:
	[
		system registeredUsers do: [:thisUser | self renderUser: thisUser on: html]
	]! !

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 14:45'!
renderStorageSpaceSettingsOn: html
	"Permet de choisir les parametres par defaut des espaces de stockage des utilisateurs"
	|typeRadio|
	typeRadio := html radioGroup.
	
	html heading level: 2; with: 'Storage space settings'.
	html form: 
	[
		html text: 'Space available for each user (in Mb) : '.
		html textInput 
			callback: [ :value | self session message: (RPSS_StorageSpace capacity: value) ];
			value: RPSS_StorageSpace capacity.
		html break.
		
		html text: 'Maximum size of files (in Kb) : '.
		html textInput
			callback: [ :value | self session message: (RPSS_StorageSpace maxSize: value) ];
			value: RPSS_StorageSpace maxSize.
		html break.
		
		html text: 'Accepted types of file: '.
		html break.
		typeRadio radioButton 
			selected: RPSS_StorageSpace acceptAllTypes;
			callback: [RPSS_StorageSpace acceptAllTypes: true].
		html text: ' accept everything.'.
		html break.
		
		typeRadio radioButton 
			selected: RPSS_StorageSpace acceptAllTypes not;
			callback: [RPSS_StorageSpace acceptAllTypes: false].
		html text: ' accept only thoses types: '.
		html break.
		
		RPSS_File typesCategories do:
		[
			:category |
			html checkbox 
				value: (RPSS_StorageSpace areAcceptedTypes: category);
				callback: [:value | RPSS_StorageSpace thosesTypes: category areAccepted: value].
			html text: ' ', category categoryName asString.
			html break.
		].
		
		html submitButton
			callback:  [];
			value: 'Save'
	].! !

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 14:14'!
renderUser: aUser on: html
	
	html listItem: 
	[
		html text: aUser email, ' '.
		html anchor
			callback: [self editSettingsOf: aUser];
			with: 'Edit personal settings'.
	]! !

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 12:25'!
renderUserApprovalOn: html

page := 'Pending approvals'.

html paragraph: 'Users waiting for approval'.

system usersToApprove do:
[
	:user |
	html form: 
	[
		html text: user email.
		html submitButton value: 'Approve'; callback: [system approveUser: user email].
		html submitButton value: 'Deny'; callback: [system denyUser: user email].
		html break.
	]
]! !

RPSS_SiteModule subclass: #RPSS_CharClassActionEditor
	instanceVariableNames: 'action characterClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_CharClassActionEditor methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:38'!
action
	action ifNil: [action := RPSS_CharacterClassAction new].
	^ action! !

!RPSS_CharClassActionEditor methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:37'!
action: anObject
	action := anObject! !

!RPSS_CharClassActionEditor methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:38'!
characterClass
	^ characterClass! !

!RPSS_CharClassActionEditor methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:38'!
characterClass: anObject
	characterClass := anObject! !

!RPSS_CharClassActionEditor methodsFor: 'as yet unclassified' stamp: 'GJ 11/9/2011 00:26'!
renderContentOn: html
	| tempPrereq |
	tempPrereq := RPSS_CharacterClassActionPrerequisite new.
	html paragraph: 'Actions Editor'; break.
	html form: [
		html submitButton value: 'Save'; callback: [
			(tempPrereq prerequisiteValue isEmpty)
				ifFalse: [self action prerequisites  add: tempPrereq].
			self answer: true.
		].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.
		
		html text: 'Dice sides: '.
		html textInput on: #proba of: self action.
		html text: ' (Set to 1 if not probabilist or use with the "Dice roll" prerequisite)'.
		html break. 
		
		html text: 'Duration: '.
		html textInput on: #duration of: self action.
		html text: 'Duration unit: '.
		html select
			list: #(#Minutes #Hours #Turns);
			selected: self action durationType;
			callback: [ :value | self action durationType: value].
		html break. 
		
		html text: 'Prerequisites: '.
		html break.
		self renderPrerequisitesListOn: html.
		self renderPrerequisitesEditor: tempPrereq on: html.
		html button value: 'New prerequisite'; callback: [self action prerequisites  add: tempPrereq].
		html break. 
		
		html text: 'Delay: '.
		html textInput on: #actionDelay of: self action.
		html break. 
		
		html text: 'Trigger: '.
		html select
			list: #();
			selected: self action trigger;
			callback: [ :value | self action trigger value].
		html break. 
		
		html text: 'Cooldown: '.
		html textInput on: #cooldown of: self action.
		html break. 
		
		html text: 'Effect: '.
		html textInput.
		html text: ' to: '.
		html select
			list: self characterClass inheritedAttributeNames;
			callback: [ :value | self action affectedAttribute: value].
		html text: ' on: '.
		html select
			list: #(#self #target);
			selected: 'target';
			callback: [ :value | self action effectTarget: value].
		html break. 
		
		].! !

!RPSS_CharClassActionEditor methodsFor: 'as yet unclassified' stamp: 'GJ 11/8/2011 23:26'!
renderPrerequisitesEditor: prerequisite on: html
	| possibilitiesList |
	possibilitiesList := self characterClass inheritedAttributeNames copy.
	possibilitiesList add: 'Dice roll'.
		html select
			list: possibilitiesList;
			callback: [ :value | prerequisite attributeName: value].
		html select
			list: #(#> #< #= #<= #>=);
			callback: [ :value | prerequisite sign: value].
		html textInput on: #prerequisiteValue of: prerequisite.! !

!RPSS_CharClassActionEditor methodsFor: 'as yet unclassified' stamp: 'GJ 11/8/2011 23:30'!
renderPrerequisitesListOn: html
	| possibilitiesList |
	possibilitiesList := self characterClass inheritedAttributeNames copy.
	possibilitiesList add: 'Dice roll'.
	self action prerequisites do: [:prerequisite | 
		html select
			list: possibilitiesList;
			selected: prerequisite attributeName;
			callback: [ :value | prerequisite attributeName: value].
		html select
			list: #(#> #< #= #<= #>=);
			selected: prerequisite sign;
			callback: [ :value | prerequisite sign: value].
		html textInput on: #prerequisiteValue of: prerequisite.
		html button value: 'Remove'; callback: [self action removePrerequisite: prerequisite].
		html break.
	].! !

RPSS_SiteModule subclass: #RPSS_CharClassAttributeEditor
	instanceVariableNames: 'attribute characterClass tempFormula tempMaxFormula'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 23:45'!
attribute
	^ attribute! !

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 23:34'!
attribute: anObject
	attribute := anObject.
	tempFormula := attribute formula copy.
	tempMaxFormula := attribute maximumFormula copy.! !

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:54'!
characterClass
	^ characterClass! !

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:54'!
characterClass: anObject
	characterClass := anObject! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/5/2011 18:57'!
chooseAttribute
	^ self chooseFrom: (self characterClass inheritedAttributeNames) caption: 'Please choose an attribute here.'.! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'GJ 11/8/2011 21:35'!
operatorsMenu: operator on: html
	|list|
	list := OrderedCollection new.
	list add: '+'; add: '-'; add: '*'; add: '/'; add: '^'; add: 'min'; add: 'max'.
	^ html select
		list: list;
		selected: operator
		! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/5/2011 19:26'!
renderContentOn: html
	html paragraph: 'Attribute Editor'; break.
	html form: [
		html submitButton value: 'Save'; callback: [self attribute formula: tempFormula. self attribute maximumFormula: tempMaxFormula. self answer: true].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.
		
		html text: 'Collection: '.
		html textInput value: (self attribute collection); callback: [:value | self attribute collection: value].
		html break; break.
		
		html text: 'Initial value: '.
		html textInput value: (self attribute initialValue); callback: [:value | self attribute initialValue: value].
		html break.
		html text: '(If not set, then players will have to define a value on character creation.)'; break; break.
		
		html text: 'Minimum: '.
		html textInput value: (self attribute minValue); callback: [:value | self attribute minValue: value].
		html break.
		
		html text: 'Maximum: '.
		html textInput value: (self attribute maxValue); callback: [:value | self attribute maxValue: value].
		html break.		
		
		html text: 'Can be modified by player: '.
		html checkbox value: (self attribute modifiable); callback: [:value | self attribute modifiable: value].
		html break.
		
		html text: 'Takes random values: '.
		html checkbox value: (self attribute random); callback: [:value | self attribute random: value].
		html break; break.
		
		html text: 'Multivalued: '.
		html checkbox value: (self attribute multivalued); callback: [:value | self attribute multivalued: value].
		html break; break.
		
		html text: 'Dynamic value: '; break.
		(tempFormula = nil) ifTrue: [
			html text: 'not defined'.
			html button value: 'Set'; callback: [tempFormula := RPSS_Formula new]
		] ifFalse: [
			self renderFormulaEditor: tempFormula on: html.
			html button value: 'Remove'; callback: [tempFormula := nil]
		].
		html break; break.
		
		html text: 'Dynamic maximum value: '; break.
		(tempMaxFormula = nil) ifTrue: [
			html text: 'not defined'.
			html button value: 'Set'; callback: [tempMaxFormula := RPSS_Formula new]
		] ifFalse: [
			self renderFormulaEditor: tempMaxFormula on: html.
			html button value: 'Remove'; callback: [tempMaxFormula := nil]
		].
	]! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'GJ 11/8/2011 21:35'!
renderFormulaEditor: formula on: html
	(formula operator = nil) ifFalse: [
		html text: '('; break.
		html div
			style: 'margin-left: 25px; border-left: 1px solid gray';
			with: [
				self renderFormulaEditor: (formula operand1) on: html.
				
				html div
					style: 'margin-left: 20px; margin-top: 10px; margin-bottom: 10px';
					with: [(self operatorsMenu: (formula operator) on: html) callback: [:value | formula operator: value]].
				
				self renderFormulaEditor: (formula operand2) on: html.	
			].
		html text: ') '.
		html button value: '><'; callback: [formula contract].
	] ifTrue: [
		html textInput value: (formula operand1); size: 5; callback: [:value | formula operand1: value].
		html button value: '<>'; callback: [formula expand].
		html button value: '...'; callback: [formula operand1: self chooseAttribute].
	]! !

RPSS_SiteModule subclass: #RPSS_CharClassEditor
	instanceVariableNames: 'characterClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'GeoffreyJacquet 10/26/2011 00:38'!
addAction: name
	|editor|
	name ifNotNil: [
		editor := RPSS_CharClassActionEditor new.
		editor characterClass: characterClass.
		(self call: editor) ifTrue: [
			characterClass actions at: name put: (editor action)
		] ifFalse: [].	
	]! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 23:45'!
addAttribute: name collection: collection
	|editor|
	name ifNotNil: [
		editor := RPSS_CharClassAttributeEditor new.
		editor attribute: RPSS_CharacterClassAttribute new.
		editor attribute collection: collection.
		editor characterClass: characterClass.
		(self call: editor) ifTrue: [
			characterClass attributes at: name put: (editor attribute)
		] ifFalse: [].	
	]! !

!RPSS_CharClassEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:24'!
characterClass
	characterClass ifNil: [characterClass := RPSS_CharacterClass new].
	^ characterClass! !

!RPSS_CharClassEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:21'!
characterClass: anObject
	characterClass := anObject! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'GeoffreyJacquet 10/26/2011 00:39'!
modifyAction: actionName
	|object editor|
	object := characterClass actions at: actionName.
	editor := RPSS_CharClassActionEditor new.
	editor characterClass: characterClass.
	editor action: (characterClass actions at: actionName).
	^ self call: editor! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 18:22'!
modifyAttribute: attributeName
	|object editor|
	object := characterClass attributes at: attributeName.
	editor := RPSS_CharClassAttributeEditor new.
	editor characterClass: characterClass.
	editor attribute: (characterClass attributes at: attributeName).
	^ self call: editor! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'GJ 11/5/2011 18:02'!
renderContentOn: html
	html paragraph: 'Character class editor'.
	html form: [
		html submitButton value: 'Save'; callback: [self answer: true].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.
		
		html text: 'Title: '.
		html textInput value: self characterClass title; callback: [:value | self characterClass title: value].
		html break; break.
		
		html text: 'Attributes:'; break.
		html button value: 'Add new collection'; callback: [
			|collection name|
			collection := (self request: 'Name for new collection?').
			name := (self request: 'Name for new attribute?').
			self addAttribute: name collection: collection.
		].


		self characterClass inheritedAttributeCollections do: [:collection |
				html break; break.
				html strong: 'Collection: '; strong: collection; text: ' '.
				html button value: 'Add Attribute'; callback: [self addAttribute: (self request: 'Name for new attribute?') collection: collection].
				html break.
				
				self characterClass inheritedAttributesFromCollection: collection do: [:name :attribute |
					html text: name.
					(self characterClass ownAttribute: name)
						ifTrue: [
							html button value: 'Modify'; callback: [self modifyAttribute: name].
							html button value: 'Remove'; callback: [self characterClass attributes removeKey: name].
						]
						ifFalse: [
							html text: ' (inherited)'.
						].
					
					html break.
				].
		].
		
		html break.
		
		html text: 'Actions:'; break.
		html button value: 'Add Action'; callback: [self addAction: (self request: 'Name for new action?')].
				
		self characterClass inheritedActions keysDo: [ :action |
			html break.
			html text: action.
			(self characterClass ownAction: action)
						ifTrue: [
							html button value: 'Modify'; callback: [self modifyAction: action].
							html button value: 'Remove'; callback: [self characterClass actions removeKey: action].
						]
						ifFalse: [
							html text: ' (inherited)'.
						].
		].
	].! !

RPSS_SiteModule subclass: #RPSS_CharClassList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:39'!
addCharacterClass
	|editor|
	editor := RPSS_CharClassEditor new.
	(self call: editor) ifTrue: [
		self session user characterClasses add: editor characterClass
	] ifFalse: [].! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/26/2011 01:53'!
duplicateCharacterClass: class
	|editor newClass|
	editor := RPSS_CharClassEditor new.
	newClass := class copy.
	newClass title: (class title, ' copy').
	editor characterClass: newClass.
	(self call: editor) ifTrue: [
		self session user characterClasses add: editor characterClass
	] ifFalse: [].! !

!RPSS_CharClassList methodsFor: 'initialization' stamp: 'BogatchevOleg 10/24/2011 14:40'!
initialize 
	super initialize.! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:32'!
modifyCharacterClass: characterClass
	|editor|
	editor := RPSS_CharClassEditor new.
	editor characterClass: characterClass.
	self call: editor.! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:31'!
removeCharacterClass: characterClass
	self session user characterClasses remove: characterClass ifAbsent: [].! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 11/6/2011 13:26'!
renderBranch: parentClass on: html
	html div
		style: 'margin-left: 25px; border-left: 1px solid gray';
		with: [
			self session user characterClasses do: [:class |
				(class parent = parentClass) ifTrue: [
					html text: class title.
					html button value: 'Remove'; callback: [self removeCharacterClass: class].
					html button value: 'Modify'; callback: [self modifyCharacterClass: class].
					html button value: 'Duplicate'; callback: [self duplicateCharacterClass: class].
					html button value: 'Subclass'; callback: [self subclassCharacterClass: class].
					self renderBranch: class on: html.
				] ifFalse: []
			]
		]! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/26/2011 01:53'!
renderContentOn: html
	html paragraph: 'Character classes:'.
	html form: [
		html button value: 'Add'; callback: [self addCharacterClass].
		self renderBranch: nil on: html. 
	]
	! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/26/2011 01:53'!
subclassCharacterClass: class
	|editor newClass|
	editor := RPSS_CharClassEditor new.
	newClass := RPSS_CharacterClass new.
	newClass parent: class.
	newClass title: ('Kind of ', class title).
	editor characterClass: newClass.
	(self call: editor) ifTrue: [
		self session user characterClasses add: editor characterClass
	] ifFalse: [].! !

RPSS_SiteModule subclass: #RPSS_CharEditor
	instanceVariableNames: 'character initial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_CharEditor methodsFor: 'accessing' stamp: 'TimLenertz 11/6/2011 15:08'!
character
	^ character! !

!RPSS_CharEditor methodsFor: 'accessing' stamp: 'TimLenertz 11/6/2011 15:08'!
character: anObject
	character := anObject! !

!RPSS_CharEditor methodsFor: 'accessing' stamp: 'TimLenertz 11/6/2011 15:42'!
characterClass
	^ character characterClass! !

!RPSS_CharEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 16:53'!
createCharacterWithClass: chClass name: name
	chClass ifNil: [^ self inform: 'You must select a class for the character!!'].
	name ifEmpty: [^ self inform: 'You must enter a name for the character!!'].
	character := RPSS_Character new initializeWithCharacterClass: chClass name: name.
	! !

!RPSS_CharEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 18:52'!
initialize
	super initialize.
	character := nil.
	initial := true.! !

!RPSS_CharEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 18:46'!
initializeWithCharacter: char
	super initialize.
	character := char.
	initial := false! !

!RPSS_CharEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 19:53'!
modifyAttribute: attr
	|val|
	attr multivalued
		ifTrue: [self inform: 'Currently not possible to edit multivalued attributes.']
		ifFalse: [
			val := attr currentValue.
			val := self request: 'Enter a new value:' default: val.
			val ifNotNil: [attr currentValue: val].
		]! !

!RPSS_CharEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 19:57'!
renderAttributeEditor: attribute named: name on: html
	html text: name, ': '.
	
	attribute defined
		ifTrue: [
			attribute random
				ifTrue: [html text: 'random (', attribute minValue, '...', attribute maxValue, ')']
				ifFalse: [html text: attribute currentValue] "TODO support for multivalued attributes"
		]
		ifFalse: [ html text: '--' ].
		
	html text: ' '.
	attribute canCalculate ifTrue: [
		html button value: 'Calculate'; callback: [attribute calculate].
	].

	html text: ' '.
	(initial | attribute modifiable) ifTrue: [
		html button value: 'Modify'; callback: [self modifyAttribute: attribute].
	]! !

!RPSS_CharEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 15:26'!
renderCharacterCreatorOn: html
	|name chClass automatic radioGroup|

	html text: 'Create new character.'.
	html break.

	html form: [
		html submitButton value: 'Proceed'; callback: [self createCharacterWithClass: chClass name: name].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.

		html text: 'Name of character: '.
		html textInput callback: [:value | name := value].
		html break; break.
		
		html text: 'Class:'.
		radioGroup := html radioGroup callback: [:value | chClass := value].
		self renderClassSelectionBranch: nil on: html radioGroup: radioGroup.
		html break.
	]! !

!RPSS_CharEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 17:33'!
renderCharacterEditorOn: html
	|attribute|

	html text: 'Character Editor: ', character name, ' (', self characterClass title, ')'.
	html break; break.
	
	html form: [
		html submitButton value: 'Save'; callback: [self answer: true].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.

		self characterClass inheritedAttributeCollections do: [:collection |
			html strong: collection.
			html break.
		
			self characterClass inheritedAttributesFromCollection: collection do: [:name :attributeClass |
				attribute := character attribute: name.
				self renderAttributeEditor: attribute named: name on: html.
				html break.
			]
		]
	]! !

!RPSS_CharEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 15:17'!
renderClassSelectionBranch: parentClass on: html radioGroup: group
	html div
		style: 'margin-left: 25px; border-left: 1px solid gray';
		with: [
			self session user characterClasses do: [:class |
				(class parent = parentClass) ifTrue: [
					group radioButton value: class.
					html text: class title.
					html break.
					self renderClassSelectionBranch: class on: html radioGroup: group.
				] ifFalse: []
			]
		]! !

!RPSS_CharEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 15:33'!
renderContentOn: html
	character
		ifNotNil: [self renderCharacterEditorOn: html]
		ifNil: [self renderCharacterCreatorOn: html]! !

RPSS_SiteModule subclass: #RPSS_CharList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_CharList methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 17:32'!
addCharacter
	|editor|
	editor := RPSS_CharEditor new.
	editor initialize.
	(self call: editor) ifTrue: [ self session user characters add: (editor character) ]
	! !

!RPSS_CharList methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 17:41'!
modifyCharacter: character
	self call: (RPSS_CharEditor new initializeWithCharacter: character). ! !

!RPSS_CharList methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 20:02'!
removeCharacter: char
	(self confirm: ('Really remove the character ', (char name), '?')) ifTrue: [
		self session user characters remove: char
	]! !

!RPSS_CharList methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 17:38'!
renderContentOn: html
	html paragraph: 'Characters'.
	
	html form: [
		html button value: 'Add Character'; callback: [self addCharacter].
		html break.
	
		html unorderedList: [
			self session user characters do: [:character |
				html listItem: [
					html text: character name.
					html button value: 'Modify'; callback: [self modifyCharacter: character].
					html button value: 'Remove'; callback: [self removeCharacter: character].
				].
			].
		]
	]! !

RPSS_SiteModule subclass: #RPSS_EditUserSettings
	instanceVariableNames: 'editedUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_EditUserSettings class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 16:40'!
user: aUser
	^ RPSS_EditUserSettings new editedUser: aUser; yourself.! !

!RPSS_EditUserSettings methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 16:35'!
editedUser
	^ editedUser! !

!RPSS_EditUserSettings methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 16:38'!
editedUser: anObject
	editedUser := anObject.! !

!RPSS_EditUserSettings methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 16:38'!
renderContentOn: html
	
	self renderStorageSpaceSettingsOn: html.! !

!RPSS_EditUserSettings methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 16:50'!
renderStorageSpaceAcceptedTypesOn: html
	"Permet de choisir les types de fichier que l'utilisateur peut uploader"
	|typeRadio|
	
	editedUser storageSpace usesDefaultAcceptedTypes ifTrue:
	[
		html text: 'The types of files this user can upload are defined by the default settings.'.
		html break.
		html text: 'You can specify personal settings :'.
		html break.
	]
	ifFalse:
	[
		html text: 'The types of files this user can upload are defined by his personal settings.'.
		html break.
		html text: 'You can '.
		html anchor 
			callback: [editedUser storageSpace useDefaultAcceptedTypes];
			with: 'use default settings.'.
		html break.
		html text: 'Or update his personal settings: '.
		html break.
	].
	
	typeRadio := html radioGroup.
	
	html form: 
	[
		typeRadio radioButton 
			selected: editedUser storageSpace acceptAllTypes;
			callback: [editedUser storageSpace acceptAllTypes: true].
		html text: ' accept everything.'.
		html break.
		
		typeRadio radioButton 
			selected: editedUser storageSpace acceptAllTypes not;
			callback: [editedUser storageSpace acceptAllTypes: false].
		html text: ' accept only thoses types: '.
		html break.
		
		RPSS_File typesCategories do:
		[
			:category |
			html checkbox 
				value: (editedUser storageSpace areAcceptedTypes: category);
				callback: [:value | editedUser storageSpace thosesTypes: category areAccepted: value].
			html text: ' ', category categoryName asString.
			html break.
		].
		
		html submitButton
			callback:  [];
			value: 'Save personal settings'
	].! !

!RPSS_EditUserSettings methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 16:57'!
renderStorageSpaceCapacityOn: html
	"Permet de choisir la capacit de l'espaces de stockage de l'utilisateur"
	|capacityRadio capacityRadioValue capacityValue|
	capacityRadio := html radioGroup.
	
	html form: 
	[
		html text: 'Space available: '.
		
		html break.
		capacityRadio radioButton 
			selected: editedUser storageSpace usesDefaultCapacity;
			callback: [capacityRadioValue := #default].
		html text: 'Default value (', RPSS_StorageSpace capacity asString, 'Mb)'.
		html break.
		
		capacityRadio radioButton 
			selected: editedUser storageSpace usesDefaultCapacity not;
			callback: [capacityRadioValue := #personal].
		html text: 'Personal value (in Mb): '.
		html textInput 
			callback: [ :value | capacityValue := value ];
			value: editedUser storageSpace capacity.
		html break.
		
		html submitButton
			callback:  [self session message: (editedUser storageSpace capacity: capacityValue using: capacityRadioValue)];
			value: 'Save'
	].! !

!RPSS_EditUserSettings methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 17:07'!
renderStorageSpaceMaxSizeOn: html
	"Permet de choisir la taille maximum des fichiers de l'utilisateur"
	|sizeRadio sizeRadioValue sizeValue|
	sizeRadio := html radioGroup.
	
	html form: 
	[
		html text: 'Maximum size of files : '.
		
		html break.
		sizeRadio radioButton 
			selected: editedUser storageSpace usesDefaultMaxSize;
			callback: [sizeRadioValue := #default].
		html text: 'Default value (', RPSS_StorageSpace maxSize asString, 'Kb)'.
		html break.
		
		sizeRadio radioButton 
			selected: editedUser storageSpace usesDefaultMaxSize not;
			callback: [sizeRadioValue := #personal].
		html text: 'Personal value (in Kb): '.
		html textInput 
			callback: [ :value | sizeValue := value ];
			value: editedUser storageSpace maxSize.
		html break.
		
		html submitButton
			callback:  [self session message: (editedUser storageSpace maxSize: sizeValue using: sizeRadioValue)];
			value: 'Save'
	].! !

!RPSS_EditUserSettings methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 16:35'!
renderStorageSpaceSettingsOn: html
	"Permet de choisir les parametres de l'espaces de stockage de l'utilisateur"
	
	html heading level: 2; with: 'Storage space settings'.
	self renderStorageSpaceCapacityOn: html.
	self renderStorageSpaceMaxSizeOn: html.
	self renderStorageSpaceAcceptedTypesOn: html.! !

!RPSS_SiteModule methodsFor: 'initialization' stamp: 'RobinDevooght 11/5/2011 13:34'!
initialize
	super initialize.
	visitor := self session visitor.
	user := self session user.
	system := RPSS_System uniqueInstance.
	page := #default.! !

!RPSS_SiteModule methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:39'!
setPage: aPage
	page := aPage.! !

RPSS_SiteModule subclass: #RPSS_UserCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:48'!
confirmCreation: anEmail with: html
	|system user urlApp urlDen|	
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	user markEmailConfirmed.
	system isUserApprovedByAdmin
	ifTrue: 
	[
		urlApp := html actionUrl copy.
		urlApp addField: (html callbacks store: (WAActionCallback on: [ system approveUser: anEmail ])).
		urlDen := html actionUrl copy.
		urlDen addField: (html callbacks store: (WAActionCallback on: [ system denyUser: anEmail ])).
		(RPSS_MailSender uniqueInstance) sendApprovalToAdmin: urlApp and: urlDen for: anEmail. 
	]
	ifFalse:
	[
		user approveByAdministrator.
	].
	visitor setMessage: 'User approved'.
	! !

!RPSS_UserCreation methodsFor: 'services' stamp: 'RobinDevooght 11/6/2011 17:50'!
confirmEmail: anEmail
	
	user := system getUserWithEmail: anEmail.
	user markEmailConfirmed.
	page := 'emailConfirm'.! !

!RPSS_UserCreation methodsFor: 'services' stamp: 'RobinDevooght 11/6/2011 17:46'!
create: html
	|url mail newUser|
	mail := RPSS_MailSender uniqueInstance.
	url := html actionUrl copy.
	url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmail: visitor email ])).
	(system verifyPassword: visitor password) & (system verifyEmail: visitor email)
	ifTrue: 
	[
		(system isEmailOccupied: visitor email)
		ifFalse: 
		[
			newUser := RPSS_User new.
			newUser fromVisitor: visitor.
			system addUser: newUser.
			mail sendEmailConfirmationTo: visitor email withUrl: url.
			self session message: 'Please confirm your email!!'.
			visitor setModule: nil.
		]
		ifTrue: 
		[
			self session message:  'This email is already taken!!'.
		].
	]
	ifFalse: 
	[
		self session message:  'Wrong email or password!!'.
	].! !

!RPSS_UserCreation methodsFor: 'initialization' stamp: 'BogatchevOleg 10/20/2011 23:13'!
initialize 
	super initialize.
	page := 'RegisterForm'.! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:33'!
renderContentOn: html
	page = 'RegisterForm'
	ifTrue:
	[
		self renderRegistrationForm: html.
	].
	page = 'emailConfirm'
	ifTrue: 
	[
		self renderEmailConfirmation: html.
	]! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'RobinDevooght 11/6/2011 17:46'!
renderEmailConfirmation: html
	html paragraph: 'Thank you for confirming your email'.
	system userApprovedByAdmin 
	ifTrue: 
	[
		self confirmCreation: visitor email with: html. 
	
	
		html paragraph: 'Administrator will approve your registration shortly'.
	].! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:34'!
renderRegistrationForm: html
	html form: 
	[
		html paragraph: 'Your e-mail adress:'.
		html textInput callback: [ :value | visitor email: value ].
		html paragraph: 'Your password:'.
		html textInput
			type: 'password';
			callback: [ :value | visitor password: value ].
		html break.
		html submitButton
			callback: [ self create: html];
			value: 'Register!!'
	].! !

RPSS_SiteModule subclass: #RPSS_UserFiles
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_UserFiles methodsFor: 'handle data' stamp: 'RobinDevooght 11/6/2011 11:31'!
deleteFile: file
	
	self session message: (user storageSpace deleteFile: file).! !

!RPSS_UserFiles methodsFor: 'handle data' stamp: 'RobinDevooght 11/5/2011 12:49'!
downloadFile: file
	
	self requestContext respond: 
	[ 
		:response | 
		response contentType: file fileType;
			document: file content;
			attachmentWithFileName: file location 
	]! !

!RPSS_UserFiles methodsFor: 'rendering' stamp: 'RobinDevooght 11/6/2011 11:57'!
renderContentOn: html

page = #default ifTrue: [self renderDefaultOn: html].
page = #share ifTrue: [self renderShareFileOn: html].! !

!RPSS_UserFiles methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 12:49'!
renderDefaultOn: html
	
	self renderUploadFormOn: html.
	
	html heading level: 2; with: 'Your files'.
	self renderFilesListOn: html.
	
	html heading level: 2; with: 'Files shared with you'.
	self renderSharedFilesOn: html.
	! !

!RPSS_UserFiles methodsFor: 'rendering' stamp: 'RobinDevooght 11/6/2011 23:14'!
renderFilesListOn: html
	"Affiche la liste des fichiers de l'utilisateur"
	
	user storageSpace filesList do: 
	[
		:eachFile |
		html anchor
			callback: [self downloadFile: eachFile];
			with: eachFile fileName.
		html text: ' - '.
		html anchor
			callback: [self shareFile: eachFile];
			with: 'Sharing options'.
		html text: ' - '.
		html anchor
			callback: [self deleteFile: eachFile];
			with: 'Delete'.
		html break.
	]! !

!RPSS_UserFiles methodsFor: 'file sharing' stamp: 'RobinDevooght 11/6/2011 23:30'!
renderShareFileOn: html
	html heading: 'Manage sharing options of ', file fileName.
	html heading level: 2; with: 'Users who share this file with you'.
	self renderSharedListOn: html.
	html heading level: 2; with: 'Other users'.
	self renderUnsharedListOn: html.! !

!RPSS_UserFiles methodsFor: 'rendering' stamp: 'RobinDevooght 11/6/2011 23:13'!
renderSharedFilesOn: html
	"Affiche la liste des fichiers partags avec l'utilisateur"
	
	user sharedFiles do: 
	[
		:eachFile |
		html anchor
			callback: [self downloadFile: eachFile];
			with: eachFile fileName.
		html break.
	]! !

!RPSS_UserFiles methodsFor: 'file sharing' stamp: 'RobinDevooght 11/6/2011 11:49'!
renderSharedListOn: html
	"Affiche la liste des utilisateurs avec qui le fichier est partag"
	
	html orderedList: 
	[
		file sharedUsers do:
		[
			:aUser |
			html listItem: 
			[
				html text: aUser email, ' - '.
				html anchor
					callback: [self session message: (file stopSharingWith: aUser)];
					with: 'stop sharing with him'.
			]
		]
	]! !

!RPSS_UserFiles methodsFor: 'file sharing' stamp: 'RobinDevooght 11/6/2011 11:48'!
renderUnsharedListOn: html
	"Affiche la liste des utilisateurs avec qui le fichier n'est pas partag"
		
	html orderedList: 
	[
		(file unsharedUsers remove: user; yourself) do:
		[
			:aUser |
			html listItem: 
			[
				html text: aUser email, ' - '.
				html anchor
					callback: [self session message: (file shareWith: aUser)];
					with: 'share with him'.
			]
		]
	]! !

!RPSS_UserFiles methodsFor: 'rendering' stamp: 'RobinDevooght 11/5/2011 17:16'!
renderUploadFormOn: html
	"Affiche le formulaire d'envoi de fichier"
	html form multipart; with: 
	[
		html fileUpload
			callback: [ :value | self uploadFile: value ].
			html submitButton: 'Send File' 
	].! !

!RPSS_UserFiles methodsFor: 'handle data' stamp: 'RobinDevooght 11/6/2011 11:38'!
shareFile: aFile
	
	page := #share.
	file := aFile.! !

!RPSS_UserFiles methodsFor: 'handle data' stamp: 'RobinDevooght 11/5/2011 17:16'!
uploadFile: file
	"Cette methode est appele par le formulaire d'envoi de fichier, elle gre l'envoi du fichier file sur le serveur, et l'ajoute dans la collection de l'utilisateur."
	
	self session message: (user storageSpace addFile: file)! !

RPSS_SiteModule subclass: #RPSS_UserGames
	instanceVariableNames: 'currentGame players'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_UserGames methodsFor: 'adds' stamp: 'DimitriVanAssche 11/7/2011 10:34'!
createGame
	"cette fonction va simplement demander le nom de la partie et va crer son instance"
	
	page := #newGame.! !

!RPSS_UserGames methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/9/2011 17:22'!
deleteGame 
	"suppression du jeu"
	self session user deleteGame: currentGame.
	currentGame := nil.
	page := #default.! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'RobinDevooght 11/8/2011 09:12'!
renderContentOn: html

	page = #default ifTrue: [self renderDefaultOn: html].
	page = #newGame ifTrue: [self renderGameCreationOn: html].
	page = #viewGame ifTrue: [self renderGameOn: html].
	page = #addPlayer ifTrue: [self renderInvitePlayersOn: html].! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'RobinDevooght 11/8/2011 11:06'!
renderDefaultOn: html
	
	self renderGamesListOn: html.
	self renderInvitationsOn: html.! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'DimitriVanAssche 11/7/2011 11:08'!
renderGameContentOn: html
	"fonction qui affichera ce que contient le jeu"! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'RobinDevooght 11/8/2011 09:29'!
renderGameCreationOn: html
	|newGame|
	

	
	
	html form:
	[	html text: 'Name fo the game : '.
		html textInput 
			callback: [:value | newGame := value.];
			value: ''.
		
		html break.
		html submitButton 
			callback: [newGame isEmptyOrNil 
							ifFalse:[page := #default.
									self session user createGame: newGame]];
			value: 'Save'. 
		html submitButton 
			callback: [page := #default. self answer: nil.];
			value: 'Cancel'. ]! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'RobinDevooght 11/8/2011 10:39'!
renderGameOn: html
	html text: 'Name of the game : ', currentGame label.
	html break.
	
	self renderGamePlayersOn: html.
	
	html break .
	html anchor
		callback:[page := #addPlayer];
		with: 'Manage invitations'.
	html break.
	html anchor
		callback: [self deleteGame.];
		with: 'Delete'.
		
	html break.! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'RobinDevooght 11/8/2011 10:32'!
renderGamePlayersOn: html
	"affiche la liste des joueurs de la partie"
	
	html text: 'Player list :'.
	
	html orderedList: 
	[
		currentGame joinedPlayers do:
		[ 
			:player | 
			html listItem: 
			[
				html text: player email.
			]
		]
	]! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'RobinDevooght 11/8/2011 11:09'!
renderGamesListOn: html
	
	html heading level: 2; with: 'Created games'.
	
	html orderedList: 
	[
		user createdGames do:
		[ 
			:game |
			html listItem: 
			[
				html anchor
					callback: [self viewGame: game];
					with: game label.
			]
		]
	].

	html anchor
		callback: [self createGame];
		with: 'Create a new game'.
		
	html heading level: 2; with: 'Joined games'.
	
	html orderedList: 
	[
		user joinedGames do:
		[ 
			:game |
			html listItem: 
			[
				html text: game label.
			]
		]
	].! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'RobinDevooght 11/8/2011 11:03'!
renderInvitationsOn: html
	
	html heading level: 2; with: 'Invitations'.
	
	html orderedList: 
	[
		user gameInvitations do:
		[ 
			:game |
			html listItem: 
			[
				html text: game label, ' '.
				html anchor
					callback: [self session message: (game joinedBy: user)];
					with: 'Join'.
			]
		]
	].! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'RobinDevooght 11/8/2011 10:37'!
renderInvitePlayersOn: html
	"Affiche la liste des utilisateurs"
	
	html heading level: 2; with: 'Invited Users'.
	
	html orderedList:
	[
		currentGame invitedPlayers do: 
		[
			:thisPlayer | 
			html listItem: 
			[
				html text: thisPlayer email, ' '.
				html anchor
					callback: [self session message: (currentGame cancelInvitationOf: thisPlayer)];
					with: 'cancel invitation'.
			]
		]
	].
	
	html heading level: 2; with:  'Other Users'.
	
	html orderedList:
	[
		currentGame uninvitedUsers do: 
		[
			:thisUser | 
			html listItem: 
			[
				html text: thisUser email, ' '.
				html anchor
					callback: [self session message: (currentGame inviteUser: thisUser)];
					with: 'invite'.
			]
		]
	]
	! !

!RPSS_UserGames methodsFor: 'rendering' stamp: 'RobinDevooght 11/8/2011 08:58'!
renderPlayersListOn: html
	"Affiche la liste des utilisateurs"
	html text: 'coucou'
	! !

!RPSS_UserGames methodsFor: 'as yet unclassified' stamp: 'DimitriVanAssche 11/7/2011 01:11'!
viewGame: aGame
	"affiche le rendu d'une partie prcise"
	page:= #viewGame.
	currentGame := aGame.! !

RPSS_SiteModule subclass: #RPSS_UserPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:55'!
changeEmail: html
	|system mail url|
	mail := RPSS_MailSender uniqueInstance.
	system := RPSS_System uniqueInstance.
	((system verifyEmail: visitor tempEmail) &  ((system isEmailOccupied: visitor tempEmail) not))
	ifTrue:
	[
		url := html actionUrl copy.
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmailChange: visitor tempEmail ])).
		mail sendEmailChangeTo: visitor email with: visitor tempEmail url: url.
	].
	visitor setMessage: 'You will receive a confirmation email with a link to confirm your change.'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 18:23'!
changePassword: html
	|system mail url|
	mail := RPSS_MailSender uniqueInstance.
	system := RPSS_System uniqueInstance.
	(system verifyPassword: visitor tempPassword)
	ifTrue:
	[
		url := html actionUrl copy.
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmPasswordChange: visitor tempPassword])).
		mail sendPasswordChangeTo: visitor email url: url.
	].
	visitor setMessage: 'You will receive a confirmation email with a link to confirm your change.'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:09'!
confirmEmailChange: aNewEmail
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: visitor email.
	system transferUserFrom: user email to: aNewEmail. 
	visitor setMessage: 'You successfuly changed your email'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 18:18'!
confirmPasswordChange: aNewPassword
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: visitor email.
	user password: aNewPassword.
	visitor setMessage: 'You successfuly changed your password'.! !

!RPSS_UserPage methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 16:26'!
initialize 
	super initialize.
	page := 'overview'.! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 16:40'!
renderChangeEmail: html
	html paragraph: 'Please input your new email'.
	html form: 
	[
		html textInput callback: [:value | visitor tempEmail: value].
		html break.
		html submitButton callback: [self changeEmail: html.]; value: 'Modify!!'.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 18:25'!
renderChangePassword: html
	html paragraph: 'Please input your new password'.
	html form: 
	[
		html textInput type: 'password'; callback: [:value | visitor tempPassword: value].
		html break.
		html submitButton callback: [self changePassword: html.]; value: 'Modify!!'.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 12:19'!
renderContentOn: html
	page = 'overview'
	ifTrue: 
	[
		html paragraph: 'Overview'.
	].
	page = 'personal'
	ifTrue: 
	[
		self renderPersonal: html.
	].
	page = 'changePassword'
	ifTrue:  
	[
		self renderChangePassword: html.
	].
	page = 'changeEmail'
	ifTrue: 
	[
		self renderChangeEmail: html.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 15:34'!
renderPersonal: html
	html paragraph: [html anchor callback: [page := 'changeEmail']; with: 'Change email'].
	html paragraph: [html anchor callback: [page := 'changePassword']; with: 'Change password'].! !

WAComponent subclass: #RPSS_Visitor
	instanceVariableNames: 'email administrator password confirmEmail message logedIn module tempEmail tempPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

RPSS_Visitor subclass: #RPSS_Administrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-View'!

!RPSS_Administrator methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/19/2011 20:03'!
confirmCreation
	|system newAdmin|
	system := RPSS_System uniqueInstance.
	(system isEmailOccupied: email)
	ifFalse: 
	[
		newAdmin := RPSS_User new.
		newAdmin email: email.
		newAdmin password: password.
		newAdmin markEmailConfirmed.
		newAdmin markAsAdministrator.
		newAdmin approveByAdministrator.
		system addUser: newAdmin.
		system finishInitialization.
		system setFirstAdministrator: newAdmin.
	]
	ifTrue: 
	[
		message := 'emailOccupied'.
	].
! !

!RPSS_Administrator methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/22/2011 17:43'!
create: html
	|system url mail|
	system := RPSS_System uniqueInstance.
	mail := RPSS_MailSender uniqueInstance.
	url := html actionUrl copy.
	url addField: (html callbacks store: (WAActionCallback on: [ self confirmCreation ])).
	(system verifyPassword: password) & (system verifyEmail: email)
	ifTrue: 
	[
		mail sendEmailConfirmationTo: email withUrl: url.
	].
	self setMessage: 'Please confirm your email.'.
	! !

!RPSS_Administrator methodsFor: 'initialization' stamp: 'BogatchevOleg 10/17/2011 22:23'!
initialize
	super initialize.
	! !

!RPSS_Administrator methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 13:45'!
initializeWithEmail: em password: pw
	super initialize.
	email := em.
	password := pw.
	administrator := true.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 10:23'!
administrator: value
	administrator := value.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 14:27'!
clearMessage
	message := nil.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:59'!
confirmEmail
	^confirmEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 12:00'!
confirmEmail: aConfirm
	confirmEmail := aConfirm.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:49'!
email
	^email.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:49'!
email: anEmail
	email := anEmail.! !

!RPSS_Visitor methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 10:24'!
fromUser: anEmail
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	self email: user email.
	self password: user password.
	self administrator: user administrator.! !

!RPSS_Visitor methodsFor: 'initialization' stamp: 'RobinDevooght 11/5/2011 16:27'!
initialize 
	super initialize.
	email := ''.
	password := ''.
	logedIn := false.
	administrator := false.
	confirmEmail := true.
	module := nil.
	tempEmail := ''.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 10:22'!
isAdministrator
	^administrator.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 14:38'!
isLogedIn
	^logedIn.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'RobinDevooght 11/6/2011 17:44'!
isLoggedIn
	^logedIn.! !

!RPSS_Visitor methodsFor: 'servicies' stamp: 'TimLenertz 10/26/2011 02:12'!
login: html
	|system|
	system := RPSS_System uniqueInstance.
	(system isUserAutorized: (self email) password: (self password))
	ifTrue: 
	[
		self fromUser: email.
		logedIn := true.
		self setModule: nil.
	]
	ifFalse: 
	[
		self setMessage: 'Wrong login/password or user not approved by administrator!!'.
	]. 
	! !

!RPSS_Visitor methodsFor: 'servicies' stamp: 'BogatchevOleg 10/22/2011 18:31'!
logout
	password := ''.
	email := ''.
	logedIn := false.
	administrator := false.
	message := ''.
	module := nil.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 14:26'!
message
	^message ifNil: [message := OrderedCollection new].! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/20/2011 23:08'!
module
	^module.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:50'!
password
	^password.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:50'!
password: aPassword
	password := aPassword.! !

!RPSS_Visitor methodsFor: 'rendering' stamp: 'BogatchevOleg 10/21/2011 10:19'!
renderContentOn: html
	html paragraph: 'To login, please provide the following information'.
	html 	form: 
			[
				html 	paragraph: 'Your e-mail adress:'.
				html 	textInput callback: [:value | self email: value].
				html 	paragraph: 'Your password:'.
				html 	textInput type: 'password'; callback: [:value | self password: value].
				html 	break.
				html 	submitButton callback: [ self login:html]; value: 'Login!!'.
			].! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 14:49'!
setMessage: aMessage.
	aMessage ifNotNil: 
	[
		self message add: aMessage.
	]! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/20/2011 23:08'!
setModule: aModule
	module := aModule.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 16:39'!
tempEmail
	^tempEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 16:40'!
tempEmail: anEmail
	tempEmail := anEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 18:14'!
tempPassword
	^tempPassword.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 18:14'!
tempPassword: aPassword
	tempPassword := aPassword.! !

TestCase subclass: #CharClassTest
	instanceVariableNames: 'attr1 attr2 charClass1 charClass2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Test'!

TestCase subclass: #PasswordEmailVerificationTest
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Test'!

TestCase subclass: #RPSSTest
	instanceVariableNames: 'system admin validUser1 validUser2 validUser3 unvalidUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Test'!

RPSSTest subclass: #FileTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Test'!

!FileTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 11:24'!
setUp
	super setUp.
	file := RPSS_File new.
	file sharedUsers: (OrderedCollection with: validUser1).! !

!FileTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/22/2011 18:52'!
testIsSharedWith
	self assert: (file isSharedWith: validUser1).
	self deny: (file isSharedWith: validUser2).! !

!FileTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 11:22'!
testSharedWith
	self deny: (file isSharedWith: validUser2).
	self deny: (file isSharedWith: unvalidUser).
	file shareWith: validUser2.
	file shareWith: unvalidUser.
	self assert: (file isSharedWith: validUser2).
	self deny: (file isSharedWith: unvalidUser).! !

!FileTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/6/2011 12:24'!
testStopSharingWith
	self assert: (file isSharedWith: validUser1).
	file stopSharingWith: validUser1.
	self deny: (file isSharedWith: validUser1).! !

RPSSTest subclass: #GameTest
	instanceVariableNames: 'game creator player invitedPlayer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Test'!

!GameTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/9/2011 17:30'!
setUp
	super setUp.
	
	game := RPSS_Game new.
	creator := RPSS_Player newUser: validUser1.
	player := RPSS_Player newUser: admin.
	invitedPlayer := RPSS_Player newUser: validUser2.
	
	game creator: validUser1.
	game addPlayer: admin.
	game addPlayer: player.
	game addPlayer: invitedPlayer.
	
	admin join.
	player join.! !

RPSSTest subclass: #PlayerTest
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Test'!

!PlayerTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 11:27'!
setUp 
	super setUp.
	
	player := RPSS_Player new.
	player user: validUser1.! !

!PlayerTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 11:28'!
testJoin
	self assert: (player isInvited).
	self deny: (player hasJoin).
	player join.
	self assert: (player hasJoin).
	self deny: (player isInvited).! !

!RPSSTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 11:32'!
setUp
	system := RPSS_System new.
	
	admin := RPSS_User new.
	admin validate.
	validUser1 := RPSS_User new.
	validUser1 validate.
	validUser1 email: 'test'.
	validUser2 := RPSS_User new.
	validUser2 validate.
	validUser2 email: 'test'.
	validUser3 := RPSS_User new.
	validUser3 validate.
	validUser3 email: 'test'.
	unvalidUser := RPSS_User new.
	
	system addUser: admin.
	system setFirstAdministrator: admin.
	system addUser: validUser1.
	system addUser: validUser2.
	system addUser: unvalidUser.
	
	! !

RPSSTest subclass: #StorageSpaceTest
	instanceVariableNames: 'defaultSettings personalizedSettings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Test'!

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 11:24'!
setUp
	super setUp.
	defaultSettings := RPSS_StorageSpace new.
	personalizedSettings := RPSS_StorageSpace new.
	personalizedSettings maxSize: 10.
	personalizedSettings capacity: 10.
	personalizedSettings acceptAllTypes: false.
	personalizedSettings acceptedTypes: (OrderedCollection new add: RPSS_FileTypesCategory textTypes;
			 yourself)! !

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 18:14'!
testAreAcceptedTypes
	self assert: (personalizedSettings areAcceptedTypes: RPSS_FileTypesCategory textTypes).
	self deny: (personalizedSettings areAcceptedTypes: RPSS_FileTypesCategory imageTypes).
	self assert: ((defaultSettings areAcceptedTypes: RPSS_FileTypesCategory textTypes) = (RPSS_StorageSpace areAcceptedTypes: RPSS_FileTypesCategory textTypes)).! !

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 18:16'!
testCapacityUsing
	(defaultSettings capacity: 'test' using: #personal).
	self assert: (defaultSettings capacity = RPSS_StorageSpace capacity).
	(defaultSettings capacity: 321 using: #personal).
	self assert: (defaultSettings capacity = 321).
	(personalizedSettings capacity: '100' using: #personal).
	self assert: (personalizedSettings capacity = 100).
	(personalizedSettings capacity: 'test200test' using: #personal).
	self assert: (personalizedSettings capacity = 200).
	(personalizedSettings capacity: '100' using: #default).
	self assert: (personalizedSettings capacity = RPSS_StorageSpace capacity).! !

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/24/2011 18:20'!
testIsAcceptedType
	self
		assert: (personalizedSettings isAcceptedType: 'text/plain').
	self
		deny: (personalizedSettings isAcceptedType: 'image/jpeg').! !

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 18:17'!
testMaxSizeUsing
	(defaultSettings maxSize: 'test' using: #personal).
	self assert: (defaultSettings maxSize = RPSS_StorageSpace maxSize).
	 (defaultSettings maxSize: 321 using: #personal).
	self assert: (defaultSettings maxSize = 321).
	(personalizedSettings maxSize: '100' using: #personal).
	self assert: (personalizedSettings maxSize = 100).
	 (personalizedSettings maxSize: 'test200test' using: #personal).
	self assert: (personalizedSettings maxSize = 200).
	(personalizedSettings maxSize: '100' using: #default).
	self assert: (personalizedSettings maxSize = RPSS_StorageSpace maxSize).! !

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 18:15'!
testThoseTypesAreAccepted
	self assert: (personalizedSettings areAcceptedTypes: RPSS_FileTypesCategory textTypes).
	personalizedSettings thosesTypes: RPSS_FileTypesCategory textTypes areAccepted: false.
	self deny: (personalizedSettings areAcceptedTypes: RPSS_FileTypesCategory textTypes).
	personalizedSettings thosesTypes: RPSS_FileTypesCategory textTypes areAccepted: true.
	self assert: (personalizedSettings areAcceptedTypes: RPSS_FileTypesCategory textTypes).! !

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: ''!
testUseDefaultAcceptedTypes
	personalizedSettings useDefaultAcceptedTypes.
	self assert: personalizedSettings usesDefaultAcceptedTypes! !

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: ''!
testUsesDefaultAcceptedTypes
	self assert: defaultSettings usesDefaultAcceptedTypes.
	self deny: personalizedSettings usesDefaultAcceptedTypes! !

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: ''!
testUsesDefaultCapacity
	self assert: defaultSettings usesDefaultCapacity.
	self deny: personalizedSettings usesDefaultCapacity! !

!StorageSpaceTest methodsFor: 'as yet unclassified' stamp: ''!
testUsesDefaultMaxSize
	self assert: defaultSettings usesDefaultMaxSize.
	self deny: personalizedSettings usesDefaultMaxSize! !

TestCase subclass: #UserOperationsTest
	instanceVariableNames: 'system size dummyOne dummyTwo dummyThree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Test'!

Object subclass: #RPSS_Character
	instanceVariableNames: 'characterClass name attributes actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_Character methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 19:10'!
attribute:  attr
	"Returns the RPSS_CharacterAttribute object for that attribute. Creates the object if it is defined for the class, but not yet in this instance."
	|attrClass attribute|
	
	(attributes keys contains: [:key | key = attr])
		ifTrue: [^ attributes at: attr]
		ifFalse: [
			attrClass := characterClass attributeNamed: attr.
			attrClass ifNil: [^ nil].
			attribute := RPSS_CharacterAttribute new initializeWithCharacterAttributeClass: attrClass character: self.
			attributes at: attr put: attribute.
			^ attribute
		]! !

!RPSS_Character methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/5/2011 23:43'!
attributeDefined: name
	"Returns true if the attribute of this name exists, and is defined. (cf RPSS_CharacterAttribute>>defined)"
	attributes contains name
		ifTrue: [^ (attributes at: name) defined]
		ifFalse: [^ false]! !

!RPSS_Character methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/5/2011 23:51'!
attributeValue: name
	"Returns the current value of tha attribute with this name, of nil if this attribute does not exist or has no defined value."
	(self attributeDefined: name)
		ifTrue: [^ (attributes at: name) currentValue]
		ifFalse: [^ nil]! !

!RPSS_Character methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 12:42'!
characterClass
	^ characterClass! !

!RPSS_Character methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 16:55'!
initializeWithCharacterClass: chClass name: aName
	|attribute|

	name := aName.
	characterClass := chClass.
	attributes := IdentityDictionary new.
	actions := IdentityDictionary new.
	
	chClass inheritedAttributeNames do: [:attrName | 
		attribute := RPSS_CharacterAttribute new initializeWithCharacterAttributeClass: (chClass attributeNamed: attrName) character: self.
		attributes at: attrName put: attribute.
	]! !

!RPSS_Character methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 02:39'!
name
	^ name! !

!RPSS_Character methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 02:39'!
name: aName
	name := aName! !

Object subclass: #RPSS_CharacterAttribute
	instanceVariableNames: 'attributeClass currentValue character'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 17:19'!
calculate
	"Set current value for attribute based on formula or initial value, and truncate if minimum/maximum defined. If ok, return true, if not possible to calculate, doesn't change the value and return false. "
	|value|
	
	attributeClass random ifTrue: [^ false].
	attributeClass formula
		ifNil: [ value := attributeClass initialValue ]
		ifNotNil: [ value := attributeClass formula evaluateForCharacter: character ].
	
	value ifNil: [^ false].
	self currentValue: value. "Truncates to constraints."
	
	^ true.
	! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 17:58'!
canCalculate
	"Returns true if if is possible to calculate a value for this attribute. Does not verify if all attributes refered to in formulas are defined, so self>>calculate may still fail"

	attributeClass random ifTrue: [^ false].
	attributeClass formula ifNil: [^ false].
	attributeClass formula
		ifNil: [ ^ attributeClass initialValue notNil ]
		ifNotNil: [ ^ true ].
	! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/5/2011 23:18'!
currentValue
	"For deterministic attributes, returns current value if one is set or has been calculated. For probabilistic attributes, returns random number between min and max."
	attributeClass random
		ifTrue: [
			|min max|
			min := attributeClass minValue. min ifNil: [^ nil].
			max := attributeClass maxValue.
			attributeClass maximumFormula ifNotNil: [max := attributeClass maximumFormula evaluateForCharacter: character].
			max ifNil: [^ nil].
			^ RPSS_RandomNumber randomNumberBetween: min and: max. 
		]
		ifFalse: [^ currentValue].! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 19:58'!
currentValue: val
	"Set the value of the attribute, and truncates to min/max constraints. This value is ignored for randomized attributes."
	|maxValue value|
	
	value := val.
	
	attributeClass minValue isNumber ifTrue: [value := value asNumber max: (attributeClass minValue)].
	maxValue := attributeClass maxValue.
	attributeClass maximumFormula ifNotNil: [maxValue := attributeClass maximumFormula evaluateForCharacter: character].
	maxValue isNumber ifTrue: [value := value asNumber min: maxValue].

	value isEmpty ifTrue: [value := nil].
	currentValue := value! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/5/2011 23:39'!
defined
	"Returns true if the current value has been set, or the value is random and both the minimal and maximum constraint are defined. "
	^ self currentValue notNil.! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 18:37'!
initialValue
	^ attributeClass initialValue! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/5/2011 22:19'!
initializeWithCharacterAttributeClass: attrClass character: char
	attributeClass := attrClass.
	character := char.
	value := nil.! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 18:26'!
maxValue
	attributeClass maximumFormula
		ifNotNil: [^ attributeClass maximumFormula evaluateForCharacter: character]
		ifNil: [^ attributeClass maxValue]! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 18:24'!
minValue
	^ attributeClass minValue! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 19:57'!
modifiable
	self random ifTrue: [^ false].
	^ attributeClass modifiable! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 18:27'!
multivalued
	^ attributeClass multivalued! !

!RPSS_CharacterAttribute methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 18:26'!
random
	^ attributeClass random! !

Object subclass: #RPSS_CharacterClass
	instanceVariableNames: 'parent title attributes actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:27'!
actions
	^ actions! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:27'!
actions: anObject
	actions := anObject! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:39'!
attributeCollections
	|collections|
	collections := OrderedCollection new.
	attributes valuesDo: [:attribute |
		collections addIfNotPresent: attribute collection
	].
	^ collections! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:48'!
attributeName: attribute
	^ attributes keyAtValue: attribute! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 11/6/2011 17:04'!
attributeNamed: name
	(attributes keys contains: [:key | key = name])
		ifTrue: [^ attributes at: name]
		ifFalse: [
			parent ifNotNil: [^ parent attributeNamed: name] ifNil: [^ nil] 	
		]! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:59'!
attributeNames
	^ attributes keys asOrderedCollection.! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:46'!
attributes
	^ attributes! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:46'!
attributes: anObject
	attributes := anObject! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:48'!
attributesFromCollection: collection do: block
	attributes keysAndValuesDo: [:name :attribute |
		(attribute collection = collection) ifTrue: [
			block value: name value: attribute.
		] ifFalse: [].
	]! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 11/5/2011 19:14'!
inheritedActions
	|allactions|
	allactions := self actions copy.
	parent = nil ifFalse: [
		allactions addAll: parent inheritedActions
	].
	^ allactions
! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 11/5/2011 19:03'!
inheritedAttributeCollections
	|allcollections|
	allcollections := self attributeCollections copy.
	parent = nil ifFalse: [
		allcollections addAllFirstUnlessAlreadyPresent: parent inheritedAttributeCollections.
	].
	^ allcollections! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 11/5/2011 19:07'!
inheritedAttributeNames
	|allnames|
	allnames := self attributeNames copy.
	parent = nil ifFalse: [
		allnames addAllFirstUnlessAlreadyPresent: parent inheritedAttributeNames.
	].
	^ allnames! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 11/5/2011 18:24'!
inheritedAttributesFromCollection: collection do: block
	parent = nil ifFalse: [parent inheritedAttributesFromCollection: collection do: block].
	self attributesFromCollection: collection do: block! !

!RPSS_CharacterClass methodsFor: 'as yet unclassified' stamp: 'GeoffreyJacquet 10/26/2011 00:28'!
initialize
	title := 'New Character Class'.
	attributes := IdentityDictionary new.
	self actions: IdentityDictionary new.! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 11/5/2011 21:12'!
instanciate
	! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'GJ 11/5/2011 17:27'!
ownAction: name
	^ actions keys includes: name! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:50'!
ownAttribute: name
	^ attributes keys includes: name! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:51'!
parent
	^ parent! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:51'!
parent: anObject
	parent := anObject! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:11'!
title
	^ title! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:11'!
title: aString
	^ title := aString! !

Object subclass: #RPSS_CharacterClassAction
	instanceVariableNames: 'proba duration durationType prerequisites actionDelay trigger lastUsed cooldown effectTarget affectedAttribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:35'!
actionDelay
	^ actionDelay! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:35'!
actionDelay: anObject
	actionDelay := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GJ 11/8/2011 22:16'!
affectedAttribute
	^ affectedAttribute! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GJ 11/8/2011 22:16'!
affectedAttribute: anObject
	affectedAttribute := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
cooldown
	^ cooldown! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
cooldown: anObject
	cooldown := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
duration
	^ duration! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
duration: anObject
	duration := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
durationType
	^ durationType! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
durationType: anObject
	durationType := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GJ 11/8/2011 22:02'!
effectTarget
	^ effectTarget! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GJ 11/8/2011 22:02'!
effectTarget: anObject
	effectTarget := anObject! !

!RPSS_CharacterClassAction methodsFor: 'as yet unclassified' stamp: 'GJ 11/5/2011 22:14'!
initialize
	self actionDelay: 0.
	self cooldown: 0.
	self proba: 1.
	self durationType: 'Turns'.
	self prerequisites: OrderedCollection new.! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:30'!
prerequisites
	^ prerequisites! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:30'!
prerequisites: anObject
	prerequisites := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
proba
	^ proba! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
proba: anObject
	proba := anObject! !

!RPSS_CharacterClassAction methodsFor: 'as yet unclassified' stamp: 'GJ 11/8/2011 23:30'!
removePrerequisite: prerequisite
	self prerequisites remove: prerequisite ifAbsent: [].! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:35'!
trigger
	^ trigger! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:35'!
trigger: anObject
	trigger := anObject! !

Object subclass: #RPSS_CharacterClassActionPrerequisite
	instanceVariableNames: 'attributeName sign prerequisiteValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
attributeName
	^ attributeName! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
attributeName: anObject
	attributeName := anObject! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'as yet unclassified' stamp: 'GJ 11/5/2011 22:17'!
initialize
	self sign: nil.
	self attributeName: nil.
	self prerequisiteValue: nil.! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
prerequisiteValue
	^ prerequisiteValue! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
prerequisiteValue: anObject
	prerequisiteValue := anObject! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
sign
	^ sign! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
sign: anObject
	sign := anObject! !

Object subclass: #RPSS_CharacterClassAttribute
	instanceVariableNames: 'collection initialValue multivalued modifiable random minValue maxValue formula maximumFormula'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:20'!
collection
	^ collection! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:20'!
collection: anObject
	collection := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 20:32'!
formula
	^ formula! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 20:32'!
formula: anObject
	formula := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
initialValue
	^ initialValue! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
initialValue: anObject
	initialValue := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:22'!
initialize
	collection := 'General'.
	formula := nil.
	initialValue := nil.
	maxValue := nil.
	maximumFormula := nil.
	minValue := nil.
	modifiable := true.
	random := false.! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
maxValue
	^ maxValue! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
maxValue: anObject
	maxValue := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 20:32'!
maximumFormula
	^ maximumFormula! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 20:32'!
maximumFormula: anObject
	maximumFormula := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
minValue
	^ minValue! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
minValue: anObject
	minValue := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
modifiable
	^ modifiable! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
modifiable: anObject
	modifiable := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 11/5/2011 19:21'!
multivalued
	^ multivalued! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 11/5/2011 19:21'!
multivalued: anObject
	multivalued := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
random
	^ random! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
random: anObject
	random := anObject! !

Object subclass: #RPSS_File
	instanceVariableNames: 'location sharedUsers fileName hashContent'
	classVariableNames: 'filesList hashList typesCategories'
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_File class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/6/2011 22:44'!
alreadyExist: file
	"renvoi true si le fichier est dja prsent sur le serveur"
	|exist hash|
	exist := false.
	
	hash := MD5 hashMessage: file rawContents.
	(self hashList includesKey: hash) ifTrue: [exist := true].
	
	^ exist! !

!RPSS_File class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:37'!
filesList
	^ filesList ifNil: [filesList := OrderedCollection new]! !

!RPSS_File class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/6/2011 22:44'!
hashList
	^ hashList ifNil: [hashList := Dictionary new]! !

!RPSS_File class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/6/2011 22:56'!
locationOfFile: file
	"si le fichier est dja prsent sur le serveur, renvoi son adresse. nil sinon"
	|location hash|
	location := nil.
	
	hash := MD5 hashMessage: file rawContents.
	(self hashList includesKey: hash) ifTrue: [location := self hashList at: hash].
	
	^ location! !

!RPSS_File class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/6/2011 23:25'!
newFile:  aFile location: location
	"Cre un nouvel objet File et l'ajoute  la collection filesList, qui contient tous les fichiers envoys sur le site."
	|file|
	file := RPSS_File new.
	file location: location; fileName: aFile fileName; hashContent: (MD5 hashMessage: aFile rawContents).
	self filesList add: file.
	^ file.! !

!RPSS_File class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/6/2011 23:27'!
reset
	filesList := nil.
	hashList := nil! !

!RPSS_File class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:37'!
typesCategories
	^ typesCategories ifNil: 
	[
		typesCategories := OrderedCollection new
			add: RPSS_FileTypesCategory musicTypes;
			add: RPSS_FileTypesCategory videoTypes;
			add: RPSS_FileTypesCategory imageTypes;
			add: RPSS_FileTypesCategory pdfTypes;
			add: RPSS_FileTypesCategory textTypes;
			yourself.
	]! !

!RPSS_File class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/6/2011 22:52'!
uploadFile: file
|stream|

stream := (FileDirectory default directoryNamed: RPSS_System uploadDirectory)
	assureExistence;
	forceNewFileNamed: file fileName.
[ stream binary; nextPutAll: file rawContents ] 
	ensure: [ stream close ].
	
self hashList at: (MD5 hashMessage: file rawContents) put: file fileName.

^file fileName.! !

!RPSS_File methodsFor: 'file informations' stamp: 'RobinDevooght 11/6/2011 11:56'!
content
	|stream content|
	stream := (FileDirectory default directoryNamed: RPSS_System uploadDirectory) fileNamed: location.
	content := stream contentsOfEntireFile.
	stream close.
	^ content! !

!RPSS_File methodsFor: 'accessing' stamp: 'RobinDevooght 11/6/2011 23:01'!
fileName
	^ fileName! !

!RPSS_File methodsFor: 'accessing' stamp: 'RobinDevooght 11/6/2011 23:02'!
fileName:  anObject
	fileName := anObject! !

!RPSS_File methodsFor: 'file informations' stamp: 'RobinDevooght 11/6/2011 11:56'!
fileType
	|stream contentType|
	stream := (FileDirectory default directoryNamed: RPSS_System uploadDirectory) fileNamed: location.
	contentType := stream contentType.
	stream close.
	^ contentType! !

!RPSS_File methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 12:55'!
hasACopyIn: listOfFiles
	"renvoi true si true si il y a dans listOfFiles un fichier pointant vers le mme emplacement physique"
	|hasCopy|
	hasCopy := false.
	listOfFiles do: 
	[
		:file |
		file location = self location ifTrue: [hasCopy := true]
	].
	^ hasCopy! !

!RPSS_File methodsFor: 'file informations' stamp: 'RobinDevooght 11/6/2011 23:23'!
hashContent
	^ hashContent! !

!RPSS_File methodsFor: 'file informations' stamp: 'RobinDevooght 11/6/2011 23:23'!
hashContent: aHash
	hashContent := aHash! !

!RPSS_File methodsFor: 'sharing' stamp: 'RobinDevooght 11/5/2011 12:55'!
isSharedWith: aUser
	^ self sharedUsers includes: aUser! !

!RPSS_File methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
location
	^ location! !

!RPSS_File methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
location: anObject
	location := anObject! !

!RPSS_File methodsFor: 'sharing' stamp: 'RobinDevooght 11/6/2011 11:46'!
shareWith: user
	"Ajoute user  la liste des personne ayant acces au fichier"
	|result|
	result := nil.
	user isValid ifTrue:
	[
		(self sharedUsers includes: user) ifFalse: [self sharedUsers add: user].
		result := 'You are sharing the file ', self location asString, ' with ', user email.
	]
	ifFalse: [result := 'You can not share files with unregistered users.'].
	^ result! !

!RPSS_File methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
sharedUsers
	^ sharedUsers ifNil: [sharedUsers := OrderedCollection new]! !

!RPSS_File methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
sharedUsers: anObject
	sharedUsers := anObject! !

!RPSS_File methodsFor: 'file informations' stamp: 'RobinDevooght 11/6/2011 11:28'!
size
	|stream size|
	stream := (FileDirectory default directoryNamed: RPSS_System uploadDirectory) fileNamed: location.
	size := stream size.
	stream close.
	^ size! !

!RPSS_File methodsFor: 'sharing' stamp: 'RobinDevooght 11/6/2011 11:48'!
stopSharingWith: user
	"Retire user de la liste des personnes ayant acces au fichier"
	|result|
	result := nil.
	(self sharedUsers includes: user) ifTrue: 
	[
		self sharedUsers remove: user.
		result := 'You are not sharing anymore the file ', self location asString, ' with ', user email.
	].
	^result! !

!RPSS_File methodsFor: 'accessing' stamp: 'RobinDevooght 11/6/2011 11:56'!
stream
	^ (FileDirectory default directoryNamed: RPSS_System uploadDirectory) fileNamed: location.! !

!RPSS_File methodsFor: 'sharing' stamp: 'RobinDevooght 11/6/2011 12:45'!
unsharedUsers
	"renvoi la liste des utilisateurs avec qui ce fichier n'est pas partag"
	|list|
	list := OrderedCollection new.
	RPSS_System uniqueInstance registeredUsers do:
	[
		:user |
		(self sharedUsers includes: user) ifFalse: [list add: user].
	].
	^list

	! !

Object subclass: #RPSS_FileTypesCategory
	instanceVariableNames: 'categoryName examples typesList'
	classVariableNames: 'filesList imageTypes musicTypes pdfTypes textTypes videoTypes'
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_FileTypesCategory class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:38'!
imageTypes
	"Renvoi la liste des types de fichiers correspondant  une image"
	^ imageTypes ifNil:
	[ 	
		imageTypes := RPSS_FileTypesCategory new 
		categoryName: 'Pictures';
		examples: 'jpeg, png, gif, ...';
		typesList: (OrderedCollection new
			add: 'image/gif';
			add: 'image/x-xbitmap';
			add: 'image/x-xpixmap';
			add: 'image/x-png';
			add: 'image/jpeg';
			add: 'image/tiff';
			add: 'image/rgb';
			add: 'image/x-ms-bmp';
			add: 'image/vnd.svf'; 
			yourself)
	]! !

!RPSS_FileTypesCategory class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:38'!
musicTypes
	"Renvoi la liste des types de fichiers correspondant  un contenu audio"
	^ musicTypes ifNil:
	[ 	
		musicTypes := RPSS_FileTypesCategory new 
		categoryName: 'Music';
		examples: 'mp3, wav, ...';
		typesList: (OrderedCollection new
			add: 'audio/basic';
			add: 'audio/x-aiff';
			add: 'audio/x-wav';
			add: 'audio/mpeg';
			add: 'audio/ogg';
			add: 'audio/mp4';
			add: 'audio/vorbis';
			yourself)
	]! !

!RPSS_FileTypesCategory class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:38'!
pdfTypes
	"Renvoi la liste des types de fichiers correspondant  un pdf"
	^ pdfTypes ifNil:
	[ 	
		pdfTypes := RPSS_FileTypesCategory new 
		categoryName: 'Pdf';
		examples: '.pdf';
		typesList: (OrderedCollection new
			add: 'application/pdf';
			yourself)
	]! !

!RPSS_FileTypesCategory class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:39'!
textTypes
	"Renvoi la liste des types de fichiers correspondant  un fichier texte"
	^ textTypes ifNil:
	[ 	
		textTypes := RPSS_FileTypesCategory new 
		categoryName: 'Text files';
		examples: '.txt';
		typesList: (OrderedCollection new
			add: 'text/plain';
			yourself)
	]! !

!RPSS_FileTypesCategory class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:39'!
videoTypes
	"Renvoi la liste des types de fichiers correspondant  une video"
	^ videoTypes ifNil:
	[ 	
		videoTypes := RPSS_FileTypesCategory new 
		categoryName: 'Videos';
		examples: 'avi, mpeg, ...';
		typesList: (OrderedCollection new
			add: 'video/mpeg';
			add: 'video/mpeg-2';
			add: 'video/quicktime';
			add: 'video/x-msvideo';
			yourself)
	]! !

!RPSS_FileTypesCategory methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
categoryName
	^ categoryName! !

!RPSS_FileTypesCategory methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
categoryName: anObject
	categoryName := anObject! !

!RPSS_FileTypesCategory methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
examples
	^ examples! !

!RPSS_FileTypesCategory methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
examples: anObject
	examples := anObject! !

!RPSS_FileTypesCategory methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
includes: type
	"renvoi true si cette catgorie contient le type pass en parametre"
	^ typesList includes: type! !

!RPSS_FileTypesCategory methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
typesList
	^ typesList! !

!RPSS_FileTypesCategory methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:55'!
typesList: anObject
	typesList := anObject! !

Object subclass: #RPSS_Formula
	instanceVariableNames: 'operator operand1 operand2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_Formula class methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/6/2011 00:08'!
calculateOperation: op operand: op1 operand: op2
	op = '+' ifTrue: [^ op1 + op2].
	op = '-' ifTrue: [^ op1 - op2].
	op = '/' ifTrue: [^ op1 / op2].
	op = '*' ifTrue: [^ op1 * op2].
	op = '^' ifTrue: [^ op1 raisedTo: op2].
	op = 'max' ifTrue: [^ op1 max: op2].
	op = 'min' ifTrue: [^ op1 min: op2].
	^ nil.! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 21:21'!
contract
	operator := operand1 operator.
	operand2 := operand1 operand2.
	operand1 := operand1 operand1.! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 11/5/2011 23:30'!
dependencies
	"Returns Collection with names of all attributes used in this formula."
	|attributes|
	attributes := Collection new.
	attributes addAllFirstUnlessAlreadyPresent: (self operandDependencies: operand1).
	operator ifNotNil: [ attributes addAllFirstUnlessAlreadyPresent: (self operandDependencies: operand2) ].
	^ attributes! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 11/6/2011 17:15'!
evaluateForCharacter: char
	"Recusively evaluates the formula, taking attribute values from the character. Returns nil if not possible (if an attribute value it refers to is undefined.)"

	|op1 op2|
	
	op1 := self evaluateOperand: operand1 forCharacter: char.
	op1 ifNil: [^ nil].
	
	operator
		ifNotNil: [
			op2 := self evaluateOperand: operand2 forCharacter: char.
			op2 ifNil: [^ nil].
			
			^ RPSS_Formula calculateOperation: operator operand: op1 operand: op2.
		]
		ifNil: [^ op1]. ! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 11/6/2011 17:49'!
evaluateOperand: operand forCharacter: char
	operand isNumber ifTrue: [^ operand].
	operand isString ifTrue: [^ char attributeValue: operand asNumber].
	(operand isMemberOf: RPSS_Formula) ifTrue: [^ operand evaluateOperandForCharacter: char].
	^ nil! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 21:22'!
expand
	operand1 := self copy.
	operator := '+'.
	operand2 := RPSS_Formula new.! !

!RPSS_Formula methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 20:53'!
initialize
	operator := nil.
	operand1 := 0.
	operand2 := 0.! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operand1
	^ operand1! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operand1: anObject
	operand1 := anObject! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operand2
	^ operand2! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operand2: anObject
	operand2 := anObject! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 11/5/2011 23:32'!
operandDependencies: operand
	operand isString ifTrue: [^ Collection with: operand].
	(operand isMemberOf: RPSS_Formula) ifTrue: [^ operand dependencies].! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operator
	^ operator! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operator: anObject
	operator := anObject! !

Object subclass: #RPSS_Game
	instanceVariableNames: 'label creator listPlayers listCharacters listDocuments system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_Game class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 09:51'!
creator: user name: nameOfGame

	|game player|
	game := self new.
	game label: nameOfGame.
	game creator: user.
	player := RPSS_Player newUser: user role: ''.
	player join.
	game addPlayer: player.
	^game
	! !

!RPSS_Game methodsFor: 'adds' stamp: 'NadineKhouzam 11/7/2011 16:49'!
addPlayer: aPlayer
	self listPlayers add: aPlayer
	! !

!RPSS_Game methodsFor: 'adds' stamp: 'RobinDevooght 11/8/2011 10:50'!
cancelInvitationOf: player
	(player isInvited)ifTrue:
	[
		self removePlayer: player.
		player user removeGame: self.
	].
	^'This invitation has been cancelled.'! !

!RPSS_Game methodsFor: 'accessing' stamp: 'DimitriVanAssche 11/7/2011 01:01'!
creator
	^ creator! !

!RPSS_Game methodsFor: 'accessing' stamp: 'DimitriVanAssche 11/7/2011 01:01'!
creator: anObject
	creator := anObject! !

!RPSS_Game methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 10:28'!
getPlayerOfUser: user
	|correspondingPlayer|
	correspondingPlayer := nil.
	self listPlayers do: 
	[
		:player |
		player user = user ifTrue: [correspondingPlayer := player].
		
	].
	^correspondingPlayer! !

!RPSS_Game methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 10:35'!
hasJoin: user
	|correspondingPlayer|
	correspondingPlayer := self getPlayerOfUser: user.
	correspondingPlayer ifNil: [^false]
	ifNotNil: [^correspondingPlayer hasJoin] ! !

!RPSS_Game methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 09:20'!
initialize
	listCharacters := OrderedCollection new.
	listDocuments := OrderedCollection new.
	listPlayers := OrderedCollection new.
	system := RPSS_System uniqueInstance.! !

!RPSS_Game methodsFor: 'adds' stamp: 'RobinDevooght 11/8/2011 10:49'!
inviteUser: user
	(self isInvited: user) | (self hasJoin: user) ifFalse:
	[
		self addPlayer: (RPSS_Player newUser: user).
		user addGame: self.
	].
	^user email asString, ' is invited'.! !

!RPSS_Game methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 10:09'!
invitedPlayers 
	
	^ self listPlayers select:
	[
		:player |
		player isInvited
	]
	
! !

!RPSS_Game methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 10:35'!
isInvited: user
	|correspondingPlayer|
	correspondingPlayer := self getPlayerOfUser: user.
	correspondingPlayer ifNil: [^false]
	ifNotNil: [^correspondingPlayer isInvited] ! !

!RPSS_Game methodsFor: 'adds' stamp: 'RobinDevooght 11/8/2011 11:05'!
joinedBy: user
	(self isInvited: user) ifTrue:
	[
		(self getPlayerOfUser: user) join.
	].
	^ 'You have joined ', self label.! !

!RPSS_Game methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 10:33'!
joinedPlayers 
	
	^ self listPlayers select:
	[
		:player |
		player hasJoin
	]
	
! !

!RPSS_Game methodsFor: 'accessing' stamp: 'DimitriVanAssche 11/7/2011 01:01'!
label
	^ label! !

!RPSS_Game methodsFor: 'accessing' stamp: 'DimitriVanAssche 11/7/2011 01:01'!
label: anObject
	label := anObject! !

!RPSS_Game methodsFor: 'accessing' stamp: 'DimitriVanA 11/6/2011 19:18'!
listCharacters
	^ listCharacters! !

!RPSS_Game methodsFor: 'accessing' stamp: 'DimitriVanA 11/6/2011 19:18'!
listCharacters: anObject
	listCharacters := anObject! !

!RPSS_Game methodsFor: 'accessing' stamp: 'DimitriVanA 11/6/2011 19:18'!
listDocuments
	^ listDocuments! !

!RPSS_Game methodsFor: 'accessing' stamp: 'DimitriVanA 11/6/2011 19:18'!
listDocuments: anObject
	listDocuments := anObject! !

!RPSS_Game methodsFor: 'as yet unclassified' stamp: 'NadineKhouzam 11/7/2011 16:55'!
listOfRoles
! !

!RPSS_Game methodsFor: 'accessing' stamp: 'NadineKhouzam 11/7/2011 16:47'!
listPlayers
	^ listPlayers ifNil: [listPlayers := OrderedCollection new]! !

!RPSS_Game methodsFor: 'accessing' stamp: 'DimitriVanA 11/6/2011 19:18'!
listPlayers: anObject
	listPlayers := anObject! !

!RPSS_Game methodsFor: 'accessing' stamp: 'NadineKhouzam 11/7/2011 16:56'!
playersWithRole: aRole
	! !

!RPSS_Game methodsFor: 'adds' stamp: 'NadineKhouzam 11/7/2011 16:49'!
removePlayer: aPlayer
	self listPlayers remove: aPlayer ifAbsent:[].
	
! !

!RPSS_Game methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 10:38'!
uninvitedUsers
	|list|
	
	list := system registeredUsers asOrderedCollection.
	self listPlayers do: 
	[
		:player |
		list remove: player user.
	].

	^ list
	
! !

Object subclass: #RPSS_MailSender
	instanceVariableNames: 'emailFrom localhost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

RPSS_MailSender class
	instanceVariableNames: 'uniqueInstance'!

RPSS_MailSender class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_MailSender class methodsFor: 'instance destruction' stamp: 'BogatchevOleg 10/17/2011 17:27'!
reset
	uniqueInstance := nil.! !

!RPSS_MailSender class methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/17/2011 23:01'!
uniqueInstance
	uniqueInstance ifNil: 
	[
		uniqueInstance := self new.
	].
	^uniqueInstance.! !

!RPSS_MailSender methodsFor: 'initialization' stamp: 'BogatchevOleg 10/18/2011 21:06'!
initialize
	super initialize.
	emailFrom := 'rpss@ulb.ac.be'.
	localhost := WideString fromString: 'http://localhost:8080'.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:20'!
sendApprovalTo: anEmail
	self
		sendMail: 'You have been approved!!'
		subject: 'Email confirmation'
		to: anEmail.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:22'!
sendApprovalToAdmin: urlApp and: urlDen for: email
	|body linkApp linkDen administrator|
	
	linkApp := localhost, urlApp greaseString.
	linkDen := localhost, urlDen greaseString.
	administrator := (RPSS_System uniqueInstance) firstAdministrator.
	body := 'A new user created an account, please validate him, his email: ', email, ' to validate ',linkApp, ' to reject ', linkDen.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: administrator email.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:23'!
sendDenialTo: anEmail
	self
		sendMail: 'You have been denied!!'
		subject: 'Email confirmation'
		to: anEmail.
! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:28'!
sendEmailChangeTo: anEmail with: newEmail url: aUrl
	|link body|
	link := localhost, aUrl greaseString.
	body := 'Please confirm that you want to change your mail from: ', anEmail, ' to ', newEmail,' with this link:', link.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: anEmail.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:29'!
sendEmailConfirmationTo: anEmail withUrl: url
	|link body|
	link := localhost, url greaseString.
	body := 'You can confirm your email via this link: ', link.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: anEmail.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:18'!
sendMail: body subject: subject to: receiver
	"Sends an email, using the SMTP configuration from the Seaside WAEmailConfiguration"
	
	|msg|
	msg := WAEmailMessage new.
	msg from: (WAEmailAddress address: emailFrom username: 'RPSS').
	msg addTo: (WAEmailAddress address: receiver username: receiver).
	msg subject: subject.
	msg body: (WAStringEmailBody string: body).
	msg send.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:30'!
sendPasswordChangeTo: anEmail url: aUrl
	|link body|
	link := localhost, aUrl greaseString.
	body := 'Please confirm that you want to change your password with this link:', link.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: anEmail.! !

Object subclass: #RPSS_Player
	instanceVariableNames: 'user role state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_Player class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 10:02'!
newUser: user
	^ self new user: user.! !

!RPSS_Player class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/8/2011 09:42'!
newUser: user role: role
	^ self new user: user; role: role.! !

!RPSS_Player methodsFor: 'accessing' stamp: 'RobinDevooght 11/8/2011 09:56'!
email
	^self user email.! !

!RPSS_Player methodsFor: 'handler' stamp: 'RobinDevooght 11/8/2011 09:41'!
hasJoin
	^(state = #hasJoin)
	! !

!RPSS_Player methodsFor: 'initialization' stamp: 'RobinDevooght 11/8/2011 09:39'!
initialize
	super initialize.
	state := #invited
	! !

!RPSS_Player methodsFor: 'handler' stamp: 'RobinDevooght 11/8/2011 10:10'!
isInvited 
	^(state = #invited)
	! !

!RPSS_Player methodsFor: 'handler' stamp: 'RobinDevooght 11/8/2011 09:40'!
join
	state := #hasJoin
	! !

!RPSS_Player methodsFor: 'accessing' stamp: 'NadineKhouzam 11/7/2011 16:40'!
role
	^ role! !

!RPSS_Player methodsFor: 'accessing' stamp: 'NadineKhouzam 11/7/2011 16:40'!
role: anObject
	role := anObject! !

!RPSS_Player methodsFor: 'accessing' stamp: 'NadineKhouzam 11/7/2011 16:40'!
user
	^ user! !

!RPSS_Player methodsFor: 'accessing' stamp: 'NadineKhouzam 11/7/2011 16:40'!
user: anObject
	user := anObject! !

Object subclass: #RPSS_RandomNumber
	instanceVariableNames: ''
	classVariableNames: 'random'
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_RandomNumber class methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/5/2011 23:11'!
randomIntegerBetween: a and: b
	^ RPSS_RandomNumber randomNumberBetween: a and: b floor.! !

!RPSS_RandomNumber class methodsFor: 'as yet unclassified' stamp: 'TimLenertz 11/5/2011 23:08'!
randomNumberBetween: a and: b
	random ifNil: [ random := Random seed: (Time totalSeconds). ].
	^ a + ((random next)*(b - a))! !

Object subclass: #RPSS_StorageSpace
	instanceVariableNames: 'filesList capacity maxSize acceptAllTypes acceptedTypes'
	classVariableNames: 'acceptAllTypes acceptedTypes capacity maxSize'
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_StorageSpace class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:39'!
acceptAllTypes
	^ acceptAllTypes ifNil: [acceptAllTypes := true]! !

!RPSS_StorageSpace class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:39'!
acceptAllTypes: aBool
	acceptAllTypes := aBool = true.! !

!RPSS_StorageSpace class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:40'!
acceptedTypes
	^ acceptedTypes ifNil: [acceptedTypes := OrderedCollection new]! !

!RPSS_StorageSpace class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:40'!
areAcceptedTypes: listOfTypes
	"renvoi true si les types listOfTypes font partie des types de fichiers accepts par dfaut"
	^ self acceptedTypes includes: listOfTypes! !

!RPSS_StorageSpace class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 14:10'!
capacity
	^ capacity ifNil: [capacity := 0]! !

!RPSS_StorageSpace class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 14:47'!
capacity: aCapacity
	"met  jour la valeur par dfaut de capacity en vrifiant que aCapacity est bien un entier"
	
	|capacityAsInteger message|
	message := nil.
	capacityAsInteger := aCapacity asInteger.
	capacityAsInteger ifNil:
	[
		message := 'The capacity of storage must be an integer.'.
	]
	ifNotNil: 
	[
		capacity = capacityAsInteger ifFalse:
		[
			capacity := capacityAsInteger.
			message := 'The capacity of the storage space has been updated.'.
		]
	].
	^message ! !

!RPSS_StorageSpace class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:41'!
maxSize
	^ maxSize ifNil: [maxSize := 0]! !

!RPSS_StorageSpace class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 14:48'!
maxSize: aSize
	"met  jour la valeur par dfaut de maxSize en vrifiant que aSize est bien un entier"
	
	|sizeAsInteger message|
	sizeAsInteger := aSize asInteger.
	message := nil.
	sizeAsInteger ifNil:
	[
		message := 'The maximum size must be an integer.'.
	]
	ifNotNil: 
	[
		maxSize = sizeAsInteger ifFalse:
		[
			maxSize := sizeAsInteger.
			message := 'The maximum size of files has been updated.'.
		]
	].
	^message ! !

!RPSS_StorageSpace class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:41'!
thosesTypes: listOfTypes areAccepted: trueOrFalse 
	"En fonction de la valeur de trueOrFalse, ajoute ou retire les types listOfTypes des types de fichiers accepts"
	trueOrFalse ifTrue: 
	[
		(acceptedTypes includes: listOfTypes) ifFalse: [acceptedTypes add: listOfTypes]
	]
	ifFalse:
	[
		(acceptedTypes includes: listOfTypes) ifTrue: [acceptedTypes remove: listOfTypes]
	]! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 16:47'!
acceptAllTypes
	"renvoi true si l'utilisateur peut uploader n'importe quel type de fichier. Si ce parametre n'est pas spcifi pour cet utilisateur, la valeur par dfaut est renvoye"
	acceptAllTypes ifNil: [^ RPSS_StorageSpace acceptAllTypes]
		ifNotNil: [^ acceptAllTypes]! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:54'!
acceptAllTypes: aBool
	acceptAllTypes := aBool = true.! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 16:47'!
acceptedTypes
	"renvoi les types de fichiers que l'utilisateur peut uploader. Si ce parametre n'est pas spcifi pour cet utilisateur, la valeur par dfaut est renvoye"
	acceptedTypes ifNil: [^ RPSS_StorageSpace acceptedTypes]
		ifNotNil: [^ acceptedTypes]! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:54'!
acceptedTypes: types
	acceptedTypes  := types! !

!RPSS_StorageSpace methodsFor: 'actions' stamp: 'RobinDevooght 11/6/2011 23:24'!
addFile: file
	"upload file sur le serveur et l'ajoute  la liste de fichiers. renvoi true si le fichier est envoy, false sinon."
	|result location|
	
	result := nil.
	(self isAcceptedType: file contentType greaseString) ifTrue: 
	[
		file size > self maxSizeInBytes ifFalse: 
		[
			(file size + self usedSpace) > self capacityInBytes ifFalse:
			[
				(RPSS_File alreadyExist: file) ifFalse:
				[ 
					location := RPSS_File uploadFile: file.
				]
				ifTrue:
				[
					location := RPSS_File locationOfFile: file.
				].
			
				filesList add: (RPSS_File newFile: file location: location).
				result := 'The file has been uploaded successfully'.
			]
			ifTrue: [result := 'You do not have enough storage space left to upload this file.'].
		]
		ifTrue: [result :=  'Your files have to be smaller than ', self maxSize asString, 'Kb'].
	]
	ifFalse: [result := 'You may not upload this type of file.', file contentType greaseString].
	
	^ result! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 12:54'!
areAcceptedTypes: typesCategory
	"renvoi true si les types listOfTypes font partie des types de fichiers que l'utilisateur peut employer"
	^ self acceptedTypes includes: typesCategory! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 16:44'!
capacity
	"renvoi la capacit de stockage de l'utilisateur. Si aucune capacit n'est spcifi pour l'utilisateur (variable d'instance capacity), l'utilisateur bnficie de la capacit par dfaut, dfinie dans la variable de classe capacity"
	capacity ifNil: [^ RPSS_StorageSpace capacity]
		ifNotNil: [^ capacity]! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:54'!
capacity: anObject
	capacity := anObject! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 17:03'!
capacity: aCapacity using: defaultOrPersonal
	"Met  jour la capacit de stockage de l'utilisateur. si defaultOrPersonal vaut #default la variable capacity est mise  nil afin d'utiliser la valeur par dfaut de capacity, sinon, capacity prend la valeur de aCapacity."
	|result| 
	result := nil.
	defaultOrPersonal = #default ifTrue:
	[
		capacity := nil.
		result := 'This user can use ', self capacity asString, ' Mb to store his files (default capacity).'.
	]
	ifFalse:
	[
		|capacityAsInteger|
		capacityAsInteger := aCapacity asInteger.
		capacityAsInteger ifNil:
		[
			result := 'The capacity of storage must be an integer.'.
		]
		ifNotNil: 
		[
			capacity = capacityAsInteger ifFalse:
			[
				capacity := capacityAsInteger.
				result := 'This user can use ', self capacity asString, ' Mb to store his files.'.
			]
		]
	].
	^result! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 12:54'!
capacityInBytes
	^ self capacity*1024*1024! !

!RPSS_StorageSpace methodsFor: 'actions' stamp: 'RobinDevooght 11/6/2011 23:29'!
deleteFile: file
	"supprime file des fichiers de l'utilisateur"
	|result|
	result := nil.
	
	(filesList includes: file) ifTrue:
	[
		filesList remove: file.
		RPSS_File filesList remove: file.
		(file hasACopyIn: RPSS_File filesList) ifFalse: 
		[
			(FileDirectory default directoryNamed: RPSS_System uploadDirectory) deleteFileNamed: file location.
			RPSS_File hashList removeKey: file hashContent.
		].
		result := 'The file: ', file fileName, ' was deleted'.
	].

	^result! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:54'!
filesList
	^ filesList! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:54'!
filesList: anObject
	filesList := anObject! !

!RPSS_StorageSpace methodsFor: 'initialsation' stamp: 'RobinDevooght 11/5/2011 12:54'!
initialize 
	super initialize.
	filesList := OrderedCollection new.! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 12:54'!
isAcceptedType: type
	"renvoi true si ce type de fichier peut tre utilis"
	|isAccepted|
	isAccepted := false.
	self acceptAllTypes ifTrue: [isAccepted := true]
	ifFalse: 
	[
		self acceptedTypes do:
		[
			:category |
			(category includes: type) ifTrue: [isAccepted := true]
		].
	].
	^ isAccepted! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 16:45'!
maxSize
	"renvoi la taille maximale des fichiers de l'utilisateur. Si aucune taille n'est spcifi pour l'utilisateur (variable d'instance maxSize), l'utilisateur bnficie de la taille par dfaut, dfinie dans la variable de classe maxSize"
	maxSize ifNil: [^ RPSS_StorageSpace maxSize]
		ifNotNil: [^ maxSize]! !

!RPSS_StorageSpace methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 12:54'!
maxSize: anObject
	maxSize := anObject! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 17:06'!
maxSize: aSize using: defaultOrPersonal
	"Met  jour la taille maximum des fichiers de l'utilisateur. si defaultOrPersonal vaut #default la variable maxSize est mise  nil afin d'utiliser la valeur par dfaut, sinon, maxSize prend la valeur de aSize."
	|result| 
	defaultOrPersonal = #default ifTrue:
	[
		maxSize := nil.
		result := 'This user can upload up to ', self maxSize asString, ' Kb (default capacity).'.
	]
	ifFalse:
	[
		|sizeAsInteger|
		sizeAsInteger := aSize asInteger.
		sizeAsInteger ifNil:
		[
			result := 'The maximum size of files must be an integer.'.
		]
		ifNotNil: 
		[
			maxSize = sizeAsInteger ifFalse:
			[
				maxSize := sizeAsInteger.
				result := 'This user can upload up to ', self maxSize asString, ' Kb'.
			]
		]
	].
	^result! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 12:54'!
maxSizeInBytes
	^ self maxSize*1024! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 12:54'!
thosesTypes: listOfTypes areAccepted: trueOrFalse 
	"En fonction de la valeur de trueOrFalse, ajoute ou retire les types listOfTypes des types de fichiers accepts"
	acceptedTypes isNil ifTrue: [acceptedTypes := OrderedCollection new].
	
	trueOrFalse ifTrue: 
	[
		(acceptedTypes includes: listOfTypes) ifFalse: [acceptedTypes add: listOfTypes]
	]
	ifFalse:
	[
		(acceptedTypes includes: listOfTypes) ifTrue: [acceptedTypes remove: listOfTypes]
	]! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 12:54'!
useDefaultAcceptedTypes
	"modifie les parametres de l'utilisateur pour que les types de fichiers qu'il peut uploader soient dfinis par les valeur par dfaut."
	acceptAllTypes := nil.
	acceptedTypes := nil.! !

!RPSS_StorageSpace methodsFor: 'actions' stamp: 'RobinDevooght 11/5/2011 12:54'!
usedSpace
	"Renvoi l'espace consom par les fichiers de l'utilisateur (en bytes)"
	|usedSpace|
	usedSpace := 0.
	filesList do: 
	[
		:file |
		usedSpace := usedSpace + file size.		
	].

	^ usedSpace! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 12:54'!
usesDefaultAcceptedTypes
	"renvoie true si les types de fichiers que l'utilisateur peut envoyer sont ceux spcifis par dfaut"
	^ acceptAllTypes isNil! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 12:54'!
usesDefaultCapacity
	"renvoi true si la capacit de stockage accessible  l'utilisateur est la valeur par dfaut"
	
	^ capacity isNil.! !

!RPSS_StorageSpace methodsFor: 'settings' stamp: 'RobinDevooght 11/5/2011 12:54'!
usesDefaultMaxSize
	"renvoi true si la taille maximale des fichiers de l'utilisateur est la valeur par dfaut"
	
	^ maxSize isNil.! !

Object subclass: #RPSS_System
	instanceVariableNames: 'users initialized emailConfRequired userApprovedByAdmin firstAdministrator gamesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

RPSS_System class
	instanceVariableNames: 'uniqueInstance'!

RPSS_System class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_System class methodsFor: 'instance destruction' stamp: 'RobinDevooght 11/6/2011 23:27'!
reset
	uniqueInstance := nil.
	RPSS_MailSender reset.
	RPSS_File reset.! !

!RPSS_System class methodsFor: 'instance destruction' stamp: 'TimLenertz 10/25/2011 14:15'!
resetWithAdministrator: email password: password
	|user|
	user := (RPSS_User new fromVisitor: (RPSS_Administrator new initializeWithEmail: email password: password)).
	user approveByAdministrator.
	RPSS_System reset.
	RPSS_System uniqueInstance
		addUser: user;
		setFirstAdministrator: user;
		finishInitialization. 
	
 ! !

!RPSS_System class methodsFor: 'instance creation' stamp: 'TimLenertz 11/6/2011 20:30'!
uniqueInstance
	uniqueInstance ifNil: [uniqueInstance := self new initialize].
	^uniqueInstance.! !

!RPSS_System class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 11/5/2011 13:57'!
uploadDirectory
	^ 'uploads'! !

!RPSS_System methodsFor: 'accessing' stamp: 'RobinDevooght 11/9/2011 16:12'!
addGame: newGame
	self gamesList add: newGame.! !

!RPSS_System methodsFor: 'operations' stamp: 'RobinDevooght 11/5/2011 15:38'!
addUser: aUser
	users at: (((aUser email) onlyLetters ) asSymbol ) put: aUser.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/21/2011 16:45'!
approveUser: anEmail
	|user mail|
	(self isEmailOccupied: anEmail)
	ifTrue: 
	[
		user := self getUserWithEmail: anEmail.
		mail := RPSS_MailSender uniqueInstance.
		user approveByAdministrator.
		mail sendApprovalTo: anEmail.
	].! !

!RPSS_System methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 15:37'!
collection
	"Collection of RPSS_User objects"
	
	^users.! !

!RPSS_System methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 15:38'!
countUsers
	users size.! !

!RPSS_System methodsFor: 'accessing' stamp: 'RobinDevooght 11/9/2011 17:27'!
deleteGame: aGame
	self gamesList remove: aGame.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/26/2011 00:00'!
denyUser: anEmail
	|mail user|
	mail := RPSS_MailSender uniqueInstance.
	(self isEmailOccupied: anEmail)
	ifTrue: 
	[
		self removeUserWithEmail: anEmail.
		mail sendDenialTo: anEmail.
	].! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:56'!
finishInitialization
	initialized := true.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/19/2011 20:01'!
firstAdministrator
	^firstAdministrator.! !

!RPSS_System methodsFor: 'accessing' stamp: 'RobinDevooght 11/9/2011 16:10'!
gamesList
	^ gamesList ifNil: [gamesList := OrderedCollection new]! !

!RPSS_System methodsFor: 'select' stamp: 'RobinDevooght 11/5/2011 15:38'!
getUserWithEmail: anEmail
	^(users at: ((anEmail) onlyLetters) asSymbol).! !

!RPSS_System methodsFor: 'initialization' stamp: 'RobinDevooght 11/5/2011 15:38'!
initialize
	super initialize.
	users := IdentityDictionary new.
	initialized := false.
	emailConfRequired := true.
	userApprovedByAdmin := true.
	firstAdministrator := nil.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 15:17'!
isEmailConfRequired
	^emailConfRequired.! !

!RPSS_System methodsFor: 'testing' stamp: 'RobinDevooght 11/5/2011 15:38'!
isEmailOccupied: anEmail
	^(users includesKey:  (((anEmail) onlyLetters ) asSymbol )).! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:47'!
isInitialized 
	^initialized.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:49'!
isUserApprovedByAdmin
	^userApprovedByAdmin.! !

!RPSS_System methodsFor: 'testing' stamp: 'RobinDevooght 11/5/2011 15:38'!
isUserAutorized: anEmail password: aPassword
	|user|
	(users includesKey: ((anEmail onlyLetters ) asSymbol))
	ifTrue: 
	[
		user := self getUserWithEmail: anEmail.
		((user password = aPassword) & (user approvedByAdministrator = true)) 
		ifTrue: 
		[
			^true.
		].
	].
	^false.! !

!RPSS_System methodsFor: 'select' stamp: 'RobinDevooght 11/5/2011 16:33'!
registeredUsers 
	^users select: [:user | user isApprovedByAdministrator & user isEmailConfirmed]! !

!RPSS_System methodsFor: 'operations' stamp: 'RobinDevooght 11/5/2011 15:38'!
removeUserWithEmail: anEmail
	users removeKey: ((anEmail onlyLetters ) asSymbol ).! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/19/2011 20:03'!
setFirstAdministrator: newAdministrator
	^firstAdministrator := newAdministrator.! !

!RPSS_System methodsFor: 'operations' stamp: 'RobinDevooght 11/5/2011 15:39'!
transferUserFrom: anEmail to: newEmail
	|user|
	user := self getUserWithEmail: anEmail.
	users removeKey: (((anEmail) onlyLetters) asSymbol).
	users at: (((newEmail) onlyLetters) asSymbol) put: user.
	user email: newEmail.


	! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:47'!
userApprovedByAdmin
	^userApprovedByAdmin.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:48'!
userApprovedByAdmin: newValue
	userApprovedByAdmin := newValue.! !

!RPSS_System methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 15:43'!
users
	"Collection of RPSS_User objects"
	
	^users! !

!RPSS_System methodsFor: 'select' stamp: 'RobinDevooght 11/5/2011 15:39'!
usersToApprove
	^users select: [:user | user isNotApprovedByAdministrator & user isEmailConfirmed]! !

!RPSS_System methodsFor: 'servicies' stamp: 'RobinDevooght 11/5/2011 16:14'!
verifyEmail: anEmail
	"must check if mail is valid, no forbidden symbols, contains @ and . etc"
	
	^ anEmail matchesRegex: '[\w.]+@[[a-zA-Z]+.]+[a-zA-Z]+'! !

!RPSS_System methodsFor: 'servicies' stamp: 'BogatchevOleg 10/25/2011 22:46'!
verifyPassword: aPassword
	^true.
	"must check if password is solid (not too short/long, not 123456 etc)"! !

Object subclass: #RPSS_User
	instanceVariableNames: 'email password administrator emailConfirmed approvedByAdministrator characterClasses storageSpace characters system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:19'!
administrator
	^administrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:19'!
administrator: value
	administrator := value.! !

!RPSS_User methodsFor: 'validation' stamp: 'BogatchevOleg 10/18/2011 21:14'!
approveByAdministrator
	approvedByAdministrator := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:09'!
approvedByAdministrator
	^approvedByAdministrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
approvedByAdministrator: anObject
	approvedByAdministrator := anObject! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
characterClasses
	^ characterClasses! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
characterClasses: anObject
	characterClasses := anObject! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 11/6/2011 01:29'!
characters
	^ characters! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 11/6/2011 01:29'!
characters: anObject
	characters := anObject! !

!RPSS_User methodsFor: 'games' stamp: 'RobinDevooght 11/9/2011 17:20'!
createGame: nameOfGame
	
	system addGame: (RPSS_Game creator: self name: nameOfGame)! !

!RPSS_User methodsFor: 'games' stamp: 'RobinDevooght 11/9/2011 17:18'!
createdGames
	^system gamesList select: 
	[
		:game |
		game creator = self
	]! !

!RPSS_User methodsFor: 'games' stamp: 'RobinDevooght 11/9/2011 17:26'!
deleteGame: aGame
	
	aGame creator = self ifTrue: 
	[
		system deleteGame: aGame.
	]! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
email
	^email.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
email: anEmail
	email := anEmail.! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
emailConfirmed: anObject
	^ emailConfirmed := anObject! !

!RPSS_User methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/19/2011 16:50'!
fromVisitor: aVisitor
	email := aVisitor email.
	password := aVisitor password.
	administrator := false.
	emailConfirmed := false.
	approvedByAdministrator := false.! !

!RPSS_User methodsFor: 'games' stamp: 'RobinDevooght 11/9/2011 17:18'!
gameInvitations
	^system gamesList select: 
	[
		:game |
		game isInvited: self
	]! !

!RPSS_User methodsFor: 'initialization' stamp: 'RobinDevooght 11/9/2011 16:20'!
initialize
	super initialize.
	email := ''.
	password := ''.
	emailConfirmed := false.
	administrator := false.
	approvedByAdministrator := false.
	characterClasses := OrderedCollection new.
	characters := OrderedCollection new.
	system := RPSS_System uniqueInstance.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 19:58'!
isAdministrator
	^administrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:46'!
isApprovedByAdministrator
	^approvedByAdministrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:45'!
isEmailConfirmed
	^emailConfirmed.! !

!RPSS_User methodsFor: 'validation' stamp: 'BogatchevOleg 10/21/2011 22:47'!
isNotApprovedByAdministrator
	^(approvedByAdministrator not).! !

!RPSS_User methodsFor: 'validation' stamp: 'RobinDevooght 11/6/2011 12:22'!
isValid
	^ self isApprovedByAdministrator & self isEmailConfirmed! !

!RPSS_User methodsFor: 'games' stamp: 'RobinDevooght 11/9/2011 17:18'!
joinedGames
	^system gamesList select: 
	[
		:game |
		game hasJoin: self
	]! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:13'!
markAsAdministrator
	administrator := true.! !

!RPSS_User methodsFor: 'validation' stamp: 'BogatchevOleg 10/18/2011 21:14'!
markEmailConfirmed
	^emailConfirmed := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
password
	^password.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
password: aPassword
	password := aPassword.! !

!RPSS_User methodsFor: 'files' stamp: 'RobinDevooght 11/5/2011 13:01'!
sharedFiles
	"renvoi la liste des fichiers partags avec cet utilisateur"
	|shared uniqueShared|
	uniqueShared := OrderedCollection new.
	shared := RPSS_File filesList select:
	[
		:file|
		file isSharedWith: self.
	].
	
	shared do:
	[
		:file |
		(file hasACopyIn: uniqueShared) ifFalse:
		[
			(file hasACopyIn: self storageSpace filesList) ifFalse:
			[
				uniqueShared add: file.
			]
		]
	].
	
	^ uniqueShared! !

!RPSS_User methodsFor: 'files' stamp: 'RobinDevooght 11/5/2011 12:59'!
storageSpace
	^ storageSpace ifNil: [storageSpace := RPSS_StorageSpace new]! !

!RPSS_User methodsFor: 'validation' stamp: 'RobinDevooght 11/6/2011 12:38'!
validate
	self approveByAdministrator.
	self markEmailConfirmed.! !

WASession subclass: #RPSS_Session
	instanceVariableNames: 'visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS-Model'!

!RPSS_Session methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 13:50'!
message
	^ self visitor message
	! !

!RPSS_Session methodsFor: 'accessing' stamp: 'RobinDevooght 11/5/2011 13:51'!
message: aMessage
	self visitor setMessage: aMessage
	! !

!RPSS_Session methodsFor: 'accessing' stamp: 'RobinDevooght 11/6/2011 17:45'!
user
	self visitor isLoggedIn ifTrue: 
	[
		^RPSS_System uniqueInstance getUserWithEmail: visitor email
	]
	ifFalse: [^nil]
	! !

!RPSS_Session methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:51'!
visitor
	visitor ifNil: [visitor := RPSS_Visitor new].
	^ visitor! !

!RPSS_Session methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:46'!
visitor: anObject
	visitor := anObject! !
